unit bhed_j;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, ExtCtrls, DBCtrls, ToolWin, ComCtrls,
  StdCtrls, variants;

type
  T_Journal = class(TForm)
    J: TTable;
    Table2: TTable;
    DS1: TDataSource;
    DataSource2: TDataSource;
    ToolBar1: TToolBar;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    JBnr: TIntegerField;
    JSollKnt: TStringField;
    JHabenKnt: TStringField;
    JUstKnt: TStringField;
    JUstP: TSmallintField;
    JSollBetrag: TBCDField;
    JHabenBetrag: TBCDField;
    JUstSoll: TBCDField;
    JUstHaben: TBCDField;
    JBuchtext: TStringField;
    JAnr: TSmallintField;
    JBeleg: TStringField;
    JDatum: TDateField;
    JSollSaldo2: TBCDField;
    JHabenSaldo2: TBCDField;
    JUstSaldo2: TBCDField;
    JOk: TStringField;
    Table2Knr: TStringField;
    Table2Bnr: TIntegerField;
    Table2SollBetrag: TBCDField;
    Table2HabenBetrag: TBCDField;
    Table2GKnt: TStringField;
    Table2Buchtext: TStringField;
    Table2Anr: TSmallintField;
    Table2Beleg: TStringField;
    Table2Datum: TDateField;
    Table2Saldo: TBCDField;
    Table2Kz: TStringField;
    DBGrid2: TDBGrid;
    DBGrid3: TDBGrid;
    Splitter1: TSplitter;
    DataSource3: TDataSource;
    Table3: TTable;
    Table3Knr: TStringField;
    Table3Bnr: TIntegerField;
    Table3SollBetrag: TBCDField;
    Table3HabenBetrag: TBCDField;
    Table3GKnt: TStringField;
    Table3Buchtext: TStringField;
    Table3Anr: TSmallintField;
    Table3Beleg: TStringField;
    Table3Datum: TDateField;
    Table3Saldo: TBCDField;
    Table3Kz: TStringField;
    Edit1: TEdit;
    suchen: TButton;
    procedure JBeforeDelete(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    procedure JBeforePost(DataSet: TDataSet);
    procedure suchenClick(Sender: TObject);
    procedure JAfterScroll(DataSet: TDataSet);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Splitter1Moved(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  _Journal: T_Journal;

implementation

{$R *.DFM}

procedure T_Journal.JBeforeDelete(DataSet: TDataSet);
begin
abort;
end;

procedure T_Journal.FormCreate(Sender: TObject);
begin
J.open;
table2.open;
table3.open;
end;

procedure T_Journal.JBeforePost(DataSet: TDataSet);
begin
try
Jbuchtext.text:=Jbuchtext.text+'*';
if table2.Locate('Knr;bnr',vararrayof([JustKnt.text,Jbnr.text]),[])
then begin
  table2.edit;
  table2buchtext.text:=Jbuchtext.text;
  table2beleg.text:=Jbeleg.text;
  table2.post;
end;
table2.Locate('Knr;bnr',vararrayof([JsollKnt.text,Jbnr.text]),[]);
table2.edit;
table2buchtext.text:=Jbuchtext.text;
table2beleg.text:=Jbeleg.text;
table3.Locate('Knr;bnr',vararrayof([JhabenKnt.text,Jbnr.text]),[]);
table3.edit;
table3buchtext.text:=Jbuchtext.text;
table3beleg.text:=Jbeleg.text;
table3.post;
table2.post;
except
J.cancel;
end;
end;

procedure T_Journal.suchenClick(Sender: TObject);
begin
try
J.DisableControls;
table2.DisableControls;
table3.DisableControls;
screen.cursor:=crAppStart;
repeat
J.next;
if pos(edit1.text,ansiuppercase(JsollKnt.text))>0 then exit else
if pos(edit1.text,ansiuppercase(JhabenKnt.text))>0 then exit else
if pos(edit1.text,Jsollbetrag.text)>0 then exit else
if pos(edit1.text,Jhabenbetrag.text)>0 then exit else
if pos(edit1.text,ansiuppercase(Jbuchtext.text))>0 then exit else
if pos(edit1.text,ansiuppercase(Jbeleg.text))>0 then exit;
until J.eof;
J.First;
finally
J.enablecontrols;
table2.enablecontrols;
table3.enablecontrols;
screen.cursor:=crDefault;
end;
end;

procedure T_Journal.JAfterScroll(DataSet: TDataSet);
begin
try
table2.Locate('Knr;bnr',vararrayof([JsollKnt.text,Jbnr.text]),[]);
table3.Locate('Knr;bnr',vararrayof([JhabenKnt.text,Jbnr.text]),[]);
except
end;
end;

procedure T_Journal.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if key=#13 then begin
  suchenClick(sender);
  key:=#0;
  end;
end;

procedure T_Journal.Splitter1Moved(Sender: TObject);
begin
dbgrid3.Height:=dbgrid2.Height ;
end;

end.
