unit bhed_kp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, ToolWin, ComCtrls, Grids, DBGrids, Db, DBTables,
  StdCtrls;

type
  T_Kontoplan = class(TForm)
    kp: TTable;
    DS1: TDataSource;
    DBGrid1: TDBGrid;
    ToolBar1: TToolBar;
    DBNavigator1: TDBNavigator;
    kpKnr: TStringField;
    kpTyp: TStringField;
    kpName: TStringField;
    kpUstKnt: TStringField;
    kpUstP: TSmallintField;
    kpSaldo: TBCDField;
    kpBudget: TBCDField;
    kpGruppe: TStringField;
    kpLastAnr: TSmallintField;
    kpSeite: TSmallintField;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure kpBeforeDelete(DataSet: TDataSet);
    procedure ComboBox1Change(Sender: TObject);
    procedure kpBeforePost(DataSet: TDataSet);
    procedure kpAfterPost(DataSet: TDataSet);
  private
    s:string[30];
  public
    { Public-Deklarationen }
  end;

var
  _Kontoplan: T_Kontoplan;

implementation

{$R *.DFM}

procedure T_Kontoplan.FormCreate(Sender: TObject);
begin
kp.Open;
end;

procedure T_Kontoplan.kpBeforeDelete(DataSet: TDataSet);
begin
abort;
end;

procedure T_Kontoplan.ComboBox1Change(Sender: TObject);
begin
kp.IndexFieldNames:=combobox1.text;
end;

procedure T_Kontoplan.kpBeforePost(DataSet: TDataSet);
begin
s:=KPknr.Text;
end;

procedure T_Kontoplan.kpAfterPost(DataSet: TDataSet);
begin
if kp.IndexFieldNames<>'knr' then kp.locate('knr',s,[]);
end;

end.

