unit bhbuchen;

interface

uses
  SysUtils, Windows, Messages, Dialogs, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, DBTables, Mask, ExtCtrls, Buttons, ComCtrls,
  dbgrids, inifiles, ShellAPI, printers, dateutils;

type
  T_Buchen = class(TForm)
    ScrollBox: TScrollBox;
    Bnr: TDBEdit;
    UstKnt: TDBEdit;
    SollBetrag: TDBEdit;
    HabenBetrag: TDBEdit;
    ustSoll: TDBEdit;
    UstHaben: TDBEdit;
    Anr: TDBEdit;
    L_beleg: TLabel;
    Beleg: TDBEdit;
    Label13: TLabel;
    Datum: TDBEdit;
    SollSaldo2: TDBEdit;
    HabenSaldo2: TDBEdit;
    UstSaldo2: TDBEdit;
    Ok: TDBEdit;
    Panel1: TPanel;
    DSjournal: TDataSource;
    PanelBuchen: TPanel;
    J: TTable;
    S: TTable;
    DSsoll: TDataSource;
    sollName: TDBEdit;
    habenName: TDBEdit;
    DShaben: TDataSource;
    H: TTable;
    HabenKnt: TDBLookupComboBox;
    SollKnt: TDBLookupComboBox;
    U: TTable;
    DSust: TDataSource;
    sollTyp: TDBEdit;
    Label11: TLabel;
    habenTyp: TDBEdit;
    ustTyp: TDBEdit;
    sollSaldo: TDBEdit;
    sollBudget: TDBEdit;
    ustName: TDBEdit;
    ustSaldo: TDBEdit;
    habenSaldo: TDBEdit;
    habenBudget: TDBEdit;
    HabenBudgetP: TDBEdit;
    UstP: TDBEdit;
    SOLL: TLabel;
    HABEN: TLabel;
    SALDOalt: TLabel;
    SALDOneu: TLabel;
    BUDGET: TLabel;
    PROZENT: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    K: TTable;
    DSkonto: TDataSource;
    BuchenVerboten: TSpeedButton;
    JournalPlus: TBitBtn;
    KontoWechsel: TSpeedButton;
    meldung: TMaskEdit;
    JournalLoeschen: TSpeedButton;
    DatumMinus: TButton;
    DatumPlus: TButton;
    AnrPlus: TButton;
    AnrMinus: TButton;
    JournalMinus: TBitBtn;
    JournalEinfuegen: TBitBtn;
    BelegMinus: TButton;
    BelegPlus: TButton;
    JBnr: TAutoIncField;
    JSollKnt: TStringField;
    JHabenKnt: TStringField;
    JUstKnt: TStringField;
    JUstP: TSmallintField;
    JSollBetrag: TBCDField;
    JHabenBetrag: TBCDField;
    JUstSoll: TBCDField;
    JUstHaben: TBCDField;
    JBuchtext: TStringField;
    JAnr: TSmallintField;
    JBeleg: TStringField;
    JDatum: TDateField;
    JSollSaldo2: TBCDField;
    JHabenSaldo2: TBCDField;
    JUstSaldo2: TBCDField;
    JOk: TStringField;
    KKnr: TStringField;
    KBnr: TIntegerField;
    KSollBetrag: TBCDField;
    KHabenBetrag: TBCDField;
    KGKnt: TStringField;
    KBuchtext: TStringField;
    KAnr: TSmallintField;
    KBeleg: TStringField;
    KDatum: TDateField;
    KSaldo: TBCDField;
    KKz: TStringField;
    UKnr: TStringField;
    UTyp: TStringField;
    UName: TStringField;
    UUstKnt: TStringField;
    UUstP: TSmallintField;
    USaldo: TBCDField;
    UBudget: TBCDField;
    UGruppe: TStringField;
    ULastAnr: TSmallintField;
    HKnr: TStringField;
    HTyp: TStringField;
    HName: TStringField;
    HUstKnt: TStringField;
    HUstP: TSmallintField;
    HSaldo: TBCDField;
    HBudget: TBCDField;
    HGruppe: TStringField;
    HLastAnr: TSmallintField;
    SKnr: TStringField;
    STyp: TStringField;
    SName: TStringField;
    SUstKnt: TStringField;
    SUstP: TSmallintField;
    SSaldo: TBCDField;
    SBudget: TBCDField;
    SGruppe: TStringField;
    SLastAnr: TSmallintField;
    Hbudgetp: TBCDField;
    Ubudgetp: TBCDField;
    sollbudgetP: TEdit;
    Label4: TLabel;
    B_ust: TButton;
    SucheKonto: TSpeedButton;
    B_suche: TSpeedButton;
    BetragPlus: TButton;
    ListBoxUst: TListBox;
    druUst: TRichEdit;
    B_2ATS: TButton;
    B_2EURO: TButton;
    Buchtext: TDBComboBox;
    B_StoVorlage: TButton;
    B_BelegALT: TButton;
    Button1: TButton;
    B_delVorlage: TButton;
    OpenDialog1: TOpenDialog;
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure SollKntExit(Sender: TObject);
    procedure HabenBetragExit(Sender: TObject);
    procedure SollBetragExit(Sender: TObject);
    procedure BuchenVerbotenClick(Sender: TObject);
    procedure DatumMinusClick(Sender: TObject);
    procedure DatumPlusClick(Sender: TObject);
    procedure DatumEnter(Sender: TObject);
    procedure DatumKeyPress(Sender: TObject; var Key: Char);
    procedure KontoWechselClick(Sender: TObject);
    procedure meldungChange(Sender: TObject);
    procedure JournalPlusClick(Sender: TObject);
    procedure JournalLoeschenClick(Sender: TObject);
    procedure AnrKeyPress(Sender: TObject; var Key: Char);
    procedure AnrPlusClick(Sender: TObject);
    procedure AnrMinusClick(Sender: TObject);
    procedure SollBetragDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SollBetragDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure JournalMinusClick(Sender: TObject);
    procedure JournalEinfuegenClick(Sender: TObject);
    procedure SollKntKeyPress(Sender: TObject; var Key: Char);
    procedure BelegPlusClick(Sender: TObject);
    procedure BelegMinusClick(Sender: TObject);
    procedure B_ustClick(Sender: TObject);
    procedure OkClick(Sender: TObject);
    procedure BetragPlusClick(Sender: TObject);
    procedure SucheKontoClick(Sender: TObject);
    procedure B_sucheClick(Sender: TObject);
    procedure BelegKeyPress(Sender: TObject; var Key: Char);
    procedure BuchtextEnter(Sender: TObject);
    procedure B_2ATSClick(Sender: TObject);
    procedure B_2EUROClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure B_StoVorlageClick(Sender: TObject);
    procedure ScrollBoxDblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure B_BelegALTClick(Sender: TObject);
    procedure SollBetragEnter(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BuchtextChange(Sender: TObject);
    procedure L_belegClick(Sender: TObject);
    procedure beleganzeige(bn:string);
    procedure sollNameDblClick(Sender: TObject);
    procedure habenNameDblClick(Sender: TObject);
    procedure B_delVorlageClick(Sender: TObject);
    procedure BelegDblClick(Sender: TObject);
    procedure meldungEnter(Sender: TObject);
  private
    originalBetrag:string[20];
    euroAlt : Currency;	
  public
  datumGesichert    : real;
  datumVorgaenger   : real;
  textdateikennung  : string[3];
  einfuegung        : boolean;
  end;

const
  FEHLER      = 'Interner Fehler: ';
  GESICHERT   = '#';
  GEBUCHT     = '=';
  VORBEREITET = '~';  {oder sonstiges Zeichen}

var
  _Buchen  : T_Buchen;
  suchwort : string[20];
  belegTx  : string[20];
  belegALT : string[20];
  belegNr,
  anrNr    : integer;

implementation

uses bhplan, bhjournal, bhkonto, bhinit, bh_main;

{$R *.DFM}

procedure T_Buchen.FormCreate(Sender: TObject);
var Inifile: TIniFile;
begin
  einfuegung:=false;
  Inifile:= TIniFile.Create('.\HuBH.Ini');
  try
    belegTx :=inifile.readstring ('DATEN','BelegTX' ,'A1');
    anrNr   :=inifile.readinteger ('DATEN','AnrNr',0);
    belegALT:=inifile.readstring ('DATEN','BelegALT','');
    belegNr :=inifile.readinteger('DATEN','BelegNR' ,0);
    textdateikennung:=inifile.ReadString('DATEN','Textdateikennung','sxw');
      inifile.writestring('DATEN','Textdateikennung',textdateikennung);
    datumgesichert:=inifile.ReadDate('Datum','Geschuetzt',1);
  finally
    Inifile.Free;
  end;
  try buchtext.items.LoadFromFile('vorlagen.txt'); except end;
  j.Open;
  s.Open;
  h.Open;
  u.Open;
  k.open;
  {suche nach erster freier Buchung: }
  if j.bof and j.eof then begin  {1.Buchungszeile mu sein!}
    j.append;
    jSollKnt .text:=_kontoplan.kontoplanKnr.text;
    jHabenKnt.text:=_kontoplan.kontoplanKnr.text;
    jOK.text:=VORBEREITET;
    jDatum.value:=date;
    try journalMinusClick(sender); except end;
    showmessage('Neue Buchhaltung angelegt');
    end;
  if jOK.text='*' then begin
    journalPlusClick(sender);
    journalMinusClick(sender);   
    try journalMinusClick(sender);
    except  // Fehlermeldung fr noch nicht aktives Fenster verhindern
    end;       
    showmessage('Vorbereitete EBK-Buchungen mit "Blauer-Pfeil-Taste-Runter" (im Buchungsfenster) buchen.)')
  end else j.last;
  while not ( (jOK.text=GESICHERT) or (jOK.text=GEBUCHT) or j.bof )
    do j.prior;
  datumVorgaenger:=jDatum.Value;  
  if not j.bof then j.next; //erste freie Jornalzeile
  j.edit;
  _journal.sucheBnr.text:=jBnr.text;
  _journal.sucheBnrChange(sender);
  okClick(sender);
  ok.Tag:=1;
end;

procedure T_Buchen.SollKntExit(Sender: TObject);
var ust : Currency;
begin
if (sollknt.text='') or (habenknt.Text='') then exit;
meldung.text:=' ';
j.refresh; j.edit;
//Sicherheitsabfragen:
if SollKnt.text=''  then s.next;
if HabenKnt.text='' then h.next;
if length(sTyp.text)=0 then begin
  jSollKnt .text:=_kontoplan.kontoplanKnr.text;
  showmessage('Vorbereitetes SOLL-Konto wurde gelscht. KONTO PRFEN');  end;
if length(hTyp.text)=0 then begin
  jHabenKnt.text:=_kontoplan.kontoplanKnr.text;
  showmessage('Vorbereitetes HABEN-Konto gelscht. KONTO PRFEN');  end;
{UST vorbesetzen: }
jUstKnt.text:='';
jUstP.text:='';
if (sTyp.text[1] in ['A','E']) and (hTyp.text[1]<>'X') then begin
  jUstKnt.text:=sUstKnt.text;
  jUstP.text  :=sUstP.text;
  sollbetrag.color:=cllime;             //grn=Netto
  end else sollbetrag.color:=claqua;
if (hTyp.text[1] in ['A','E']) and (sTyp.text[1]<>'X') then begin
  jUstKnt.text:=hUstKnt.text;
  jUstP.text:=hUstP.text;
  habenbetrag.color:=cllime;            //grn=Netto
  end else habenbetrag.color:=claqua;
// Soll und Haben Betrag fr AE-Kontos neu berechnen:
if (jHabenBetrag.text<>'') and (jSollBetrag.text<>'') then
  if hTyp.text[1] in ['A','E']   {AE-Konto mu ja immer netto sein}
    then jHabenBetrag.value:=jSollBetrag.value/(1+jUstP.value/100)
    else if sTyp.text[1] in ['A','E']
      then jSollBetrag.value:=jHabenBetrag.value/(1+jUstP.value/100)
      else {siehe Fehlermeldung};
// UST Betrag berechnen:
ust:=jHabenBetrag.value-jSollBetrag.value;
if ust>0 then begin
  jUstSoll.value:=ust;
  jUstHaben.text:='';
  end else begin
  jUstHaben.value:=abs(ust);
  jUstSoll.text:='';
  end;
// Salden berechnen:
jSollSaldo2.value :=sSaldo.value+jSollBetrag.value;
jHabenSaldo2.value:=hSaldo.value-jHabenBetrag.value;
jUstSaldo2.value  :=uSaldo.value+jUstSoll.value-jUstHaben.value;
// Budget berechnen:
if sBudget.value=0
  then sollBudgetp.text:=''
  else sollBudgetp.text:=' '+
                    floatToStr(round(jSollSaldo2.value/sBudget.value*100));
if hBudget.value=0
  then habenBudgetp.text:=''
  else habenBudgetp.text:=' '+
                    floatToStr(round(jhabenSaldo2.value/hBudget.value*100));
// Meldungen:
if (sTyp.text[1]='A') then meldung.text:=' A U S G A B E oder W E';
if (hTyp.text[1]='E') then meldung.text:=' E I N N A H M E';
if ((sTyp.text[1]in['B','U','K']) and (hTyp.text[1]in['B','U','K'])) then
  meldung.text:=' U M B U C H U N G';
// Warnungen (FARBEN):
if jDatum.value<datumVorgaenger    // Datum kleiner
  then datum.color:=clyellow else datum.color:=claqua;
if (sTyp.text[1]='B')and     // letzte Auszug Nr = blau
   ((jAnr.value<sLastAnr.value)or(jAnr.value>sLastAnr.value+1)) or (
   (hTyp.text[1]='B')and
   ((jAnr.value<hLastAnr.value)or(jAnr.value>hLastAnr.value+1)) )
  then anr.color:=clyellow
  else anr.color:=claqua;    // Anr abweichend   = gelb
if (sTyp.text[1]='B')and     // Anr fortlaufend  = grn
   ((jAnr.value=sLastAnr.value+1) ) or (
   (hTyp.text[1]='B')and
   ((jAnr.value=hLastAnr.value+1) ) )
  then anr.color:=cllime;
if length(jbuchtext.text)>45      ///neu
  then buchtext.Color:=clyellow
  else buchtext.Color:=claqua;
// Warnungen (MELDUNGSZEILE):
if (sTyp.text[1]='E') then
  meldung.text:='W: GUTSCHRIFT auf EINNAHME (=AUSGABE)';
if (hTyp.text[1]='A') then
  meldung.text:='W: GUTSCHRIFT auf AUSGABE (=EINNAHME)';
if ((sTyp.text[1]in['B']) and (hTyp.text[1]in['B'])) then
  meldung.text:='WARNUNG: Soll- und Haben-Konto ist ein B-Konto';
if ((sTyp.text[1]in['X']) or (hTyp.text[1]in['X'])) then
  meldung.text:=' Erffnung-/Abschlubuchung (ohne autom. Ust Berechnung)';
// Fehlermeldungen:
if ((sTyp.text[1]='K') and (JsollSaldo2.value<0)) or
   ((hTyp.text[1]='K') and (JhabenSaldo2.value<0)) then
  meldung.text:='FEHLER: Saldo KASSA-KONTO kleiner 0 !';
if not (sTyp.text[1] in ['A'..'Z']) or (sKnr.text='') then
  meldung.text:='FEHLER: Soll Konto ist geschtzt';
if not (hTyp.text[1] in ['A'..'Z']) or (hKnr.text='') then
  meldung.text:='FEHLER: Haben Konto ist geschtzt';
if (jSollBetrag.value<=0) or (jHabenBetrag.value<=0) then
  meldung.text:='FEHLER: Betrag darf nicht negativ oder null sein';
if (sTyp.text[1] in ['A','E']) and (hTyp.text[1] in ['A','E']) then
  meldung.text:='FEHLER: Nur ein EA Konto erlaubt';
if (jSollKnt.text=jHabenKnt.text) then
  if (jSollBetrag.text='') or (jSollBetrag.Value=0) then begin
    meldung.text:='F: Bitte neue Buchung eingeben';
    if journalPlus.focused then sollKnt.setfocus;
  end else meldung.text:='FEHLER: Soll u. Haben Konto darf nicht gleich sein';
if jDatum.value<=DatumGesichert then
  meldung.text:='FEHLER: Datum gesicherter Buchungen '+datetostr(datumgesichert);
if (jUstP.text='') and (Ust<>0) then
  meldung.text:='FEHLER: Betrge oder Konten falsch';
if _init.strengesDatum.Checked and (j.RecNo>1) and (monthof(jDatum.Value)<monthof(datumvorgaenger)) then
  meldung.text:='FEHLER: Datum liegt nicht in Buchungsperiode';
_journal.j.Refresh;
end;

procedure T_Buchen.HabenBetragExit(Sender: TObject);
begin
if (sollknt.text='') or (habenknt.Text='') then exit;
jHabenBetrag.value:=abs(jHabenBetrag.value);
if (hTyp.text[1] in ['A','E']) and (jHabenBetrag.value<>0)
  then jSollBetrag.value:=round(jHabenBetrag.value*(1+jUstP.value/100)*100)/100
  else jSollBetrag.value:=round(jHabenBetrag.value/(1+jUstP.value/100)*100)/100;
sollKntExit(sender);
end;

procedure T_Buchen.SollBetragExit(Sender: TObject);
begin
if (sollknt.text='') or (habenknt.Text='') then exit;
jSollBetrag.value:=abs(jSollBetrag.value);
if (sTyp.text[1] in ['A','E']) and (jSollBetrag.value<>0)
  then jHabenBetrag.value:=round(jSollBetrag.value*(1+jUstP.value/100)*100)/100
  else jHabenBetrag.value:=round(jSollBetrag.value/(1+jUstP.value/100)*100)/100;
sollKntExit(sender);
end;

procedure T_Buchen.BuchenVerbotenClick(Sender: TObject);
var MyBookmark: TBookmark;
    Inifile: TIniFile;
begin
MyBookmark := j.GetBookmark; // Vorbesetzung um Warnung auszublenden
j.prior; datumvorgaenger:=jDatum.value; j.next; j.edit;
if datumvorgaenger>=jDatum.value then begin
  showmessage('Bitte zuerst Datum aktueller Buchung auf nchsten Tag stellen');
  exit;
  end;
if (messageDlg('Sind alle Buchungen (auch UST-Abschlu) bis zum '
  +dateToStr(jDatum.value-1)             ///+dateToStr(datumVorgaenger)
  +' gebucht und sollen fr jede weitere Manipulation geschtzt werden?'
  ,mtConfirmation , [mbNo,mbYes], 0) = mrYes)
  then try
    j.DisableControls;
    SCREEN.cursor:=crHourglass;
    MyBookmark := j.GetBookmark;
    datumGesichert:=jDatum.value-1;  //hh2005
    j.prior;
    while not (j.bof or (jOk.text=GESICHERT)) do begin
      j.edit;
      jok.text:=GESICHERT;
      j.prior;
    end;
    Inifile:= TIniFile.Create('.\HuBH.Ini');
    Inifile.writestring('Datum','Geschuetzt',dateToStr(datumGesichert));
  finally
    j.EnableControls;
    screen.cursor:=crDefault;
    j.GotoBookmark(MyBookmark);
    j.FreeBookmark(MyBookmark);
    j.edit;
    Inifile.Free;
  end;
end;

procedure T_Buchen.DatumMinusClick(Sender: TObject);
begin
  datum.setfocus;
  jdatum.value:=jDatum.value-1;
  sollKntExit(sender);
end;

procedure T_Buchen.DatumPlusClick(Sender: TObject);
begin
  datum.setfocus;
  jdatum.value:=jDatum.value+1;
  sollKntExit(sender);
end;

procedure T_Buchen.DatumEnter(Sender: TObject);
begin
datum.sellength:=pos('.',datum.text)-1;
end;

procedure T_Buchen.DatumKeyPress(Sender: TObject; var Key: Char);
begin
case key of
  '+' : begin datumPlusClick(sender); key:=#0; end;
  '-' : begin datumMinusClick(sender); key:=#0; end;
  #13 : begin key:=#0; postMessage(handle,WM_NextDlgCtl,0,0); end;
  end;
end;

procedure T_Buchen.KontoWechselClick(Sender: TObject);
var x : string[20];
    n : Currency;
begin
x:=jHabenKnt.text;
n:=jHabenBetrag.value;
jHabenKnt.text    :=jSollKnt.text;
jHabenBetrag.value:=jSollBetrag.value;
jSollKnt.text     :=x;
jSollBetrag.value :=n;
if sollBetrag.focused  then habenBetrag.setFocus;
if habenBetrag.focused then sollBetrag.setFocus;
sollKntExit(sender);
end;

procedure T_Buchen.meldungChange(Sender: TObject);
begin
case meldung.text[1] of
 'F' : begin meldung.color:=clred; meldung.Font.Color:=clwhite; end;
 'W' : begin meldung.color:=clyellow; meldung.Font.Color:=clblue; end;
 else  begin meldung.color:=clSilver; meldung.Font.Color:=clgreen; end;
end;
end;

procedure T_Buchen.JournalPlusClick(Sender: TObject);
begin
 if (sollknt.text='') or (habenknt.Text='') then begin
   sollKnt.SetFocus;
   exit;
 end;  
 euroalt:=0;
 sollKntExit(sender);
 j.refresh; j.edit;
 //Aussprung bei FEHLER:
 if (meldung.color=clred) then begin
   showmessage('Bitte zuerst ROTE Fehlermeldungen beseitigen!');
   ///2008 entfernt da ungewollt gebucht werden kann: sollknt.SetFocus;
   exit; //---------------->
 end;
 //Buchungsnummer eintragen:
 jBnr.value:=j.recNo;
 if k.locate('bnr',jbnr.text,[]) then begin
   showmessage(FEHLER+' AlteBuchung '+jBnr.text);
   while k.locate('Bnr',jBnr.text,[]) do k.delete;
 end;
 //aktuellstes Datum voreinstellen:
 //////if datumVorgaenger<jDatum.value then datumVorgaenger:=jDatum.value;
 datumVorgaenger:=jDatum.value;
 //Doppelte Hauptbuch Buchungen und evt. Ust Buchung:
 ///? k.edit;
 s.edit; h.edit; u.edit;
 k.insert;                       // SOLL-KONTO:
 kKnr.text         :=jSollKnt.text;
 kGknt.text        :=jHabenKnt.text;
 kSollBetrag.value :=jSollBetrag.value;
 kHabenBetrag.text :='';
 kSaldo.value      :=jSollSaldo2.value;
 sSaldo.value      :=jSollSaldo2.value;     {soll Saldo}
 kBuchtext.text    :=jBuchtext.text;
 kAnr.value        :=jAnr.value;
 kBeleg.text       :=jBeleg.text;
 kDatum.text       :=jDatum.text;
 kBnr.value        :=jBnr.value;
 sLastAnr.value    :=jAnr.value;            {soll Anr}
 k.insert;                       // HABEN-KONTO:
 kKnr.text         :=jHabenKnt.text;
 kGknt.text        :=jSollKnt.text;
 kSollBetrag.text  :='';
 kHabenBetrag.value:=jHabenBetrag.value;
 kSaldo.value      :=jHabenSaldo2.value;
 hSaldo.value      :=jHabenSaldo2.value;    {haben Saldo}
 kBuchtext.text    :=jBuchtext.text;
 kAnr.value        :=jAnr.value;
 kBeleg.text       :=jBeleg.text;
 kDatum.text       :=jDatum.text;
 kBnr.value        :=jBnr.value;
 hLastAnr.value    :=jAnr.value;            {haben Anr}
 if jUstKnt.text<>'' then begin  // UST-KONTO:
   k.insert;
   kKnr.text         :=jUstKnt.text;
   if sTyp.text[1] in ['A','E']
     then kGknt.text :=jSollKnt.text
     else kGknt.text :=jHabenKnt.text;
   kSollBetrag.value :=jUstSoll.value;
   kHabenBetrag.value:=jUstHaben.value;
   kSaldo.value      :=jUstSaldo2.value;
   uSaldo.value      :=jUstSaldo2.value;   {Ust Saldo}
   uLastAnr.value    :=jAnr.value;         {Ust Anr}
   kBuchtext.text    :=jBuchtext.text;
   kAnr.value        :=jAnr.value;
   kBeleg.text       :=jBeleg.text;
   kDatum.text       :=jDatum.text;
   kBnr.value        :=jBnr.value;
   end;
 k.post;
 s.post; h.post; u.post;
 //Buchung Kennzeichnen
 jok.text:=GEBUCHT;
 //Letzte Belegnummer merken:
 try
 if (length(beleg.text)>0) and (beleg.text[1] in ['0'..'9'])
    and (strToInt(beleg.text)>belegNR)
    then belegNR:=strToInt(beleg.text)
    else belegTX:=beleg.text;
 except
    else belegTX:=beleg.text;
 end;
 //Nchste Journalzeile selektieren und VERBEREITET kennzeichnen:
 j.next;
 if j.eof then journalEinfuegenClick(sender);
 j.edit; jok.text:=VORBEREITET; j.post;
 j.edit;
 //akltuelle BELEGBEZEICHNUNG (fr UNDO) sichern:
 belegALT:=beleg.text;
 //Aktualisieren:
 sollKntExit(sender);
 _journal.sucheBnr.text:=jBnr.text;
 _konto.k2.Refresh;
 _konto.k2.First;  //aktuellste Buchungszeile anzeigen!
 _konto.EditSaldo.Text:='';
 if (sTyp.text[1]='B') then anrNr:=jAnr.Value;
end;


procedure T_Buchen.JournalLoeschenClick(Sender: TObject);
begin
if (jok.text=GESICHERT) or (jok.text=GEBUCHT) then begin          ///2008 frher mit:  or (jBnr.text='')
  messageDlg('Letzte Buchungszeile',mtInformation,[mbOk],0);
  sollbetrag.Text:='';
  habenbetrag.Text:='';
  buchtext.Text:='';
  anr.Text:='';
  beleg.Text:='';
  ustKnt.Text:='';
  ustp.Text:='';
  meldung.text:='F: Bitte neue Buchung eingeben';
end else if (MessageDlg('Soll Buchungszeile wirklich GELSCHT ?',
     mtconfirmation, [mbNo,mbYes], 0) = mrYes) then begin
  j.delete;
  j.edit;
  end;
if j.eof then journalEinfuegenClick(sender);
_journal.j.Refresh;
end;

procedure T_Buchen.AnrKeyPress(Sender: TObject; var Key: Char);
begin
case key of
  '+' : begin AnrPlusClick(sender); key:=#0; end;
  '-' : begin AnrMinusClick(sender); key:=#0; end;
  #13 : begin key:=#0; postMessage(handle,WM_NextDlgCtl,0,0); end;
  end;
end;

procedure T_Buchen.AnrPlusClick(Sender: TObject);
begin
Anr.setfocus;
jAnr.value:=anrNr+1;
sollKntExit(sender);
end;

procedure T_Buchen.AnrMinusClick(Sender: TObject);
begin
Anr.setfocus;
jAnr.value:=anrNr;
sollKntExit(sender);
end;

procedure T_Buchen.SollBetragDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
Accept:=true;
end;

procedure T_Buchen.SollBetragDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var i  : byte;
    sx : string[60];
begin
(Sender as TDBedit).setfocus;
sx:=sollBetrag.text;
if (source is TDBEdit) then
  sx:=(Source as TDBEdit).text
  else if (source is TDBGrid) then
    if buchtext.focused
      then sx:=(Source as TDBgrid).fields[3].text
      else if (Source as TDBgrid).fields[0].text=''
        then sx:=(Source as TDBgrid).fields[1].text
        else sx:=(Source as TDBgrid).fields[0].text;
for i:=length(sx) downto 1 do
  if (sx[i]=ThousandSeparator) then delete(sx,i,1);
try sx:=FloatToStr(abs(strToFloat(sx)));
except
on econvertError do;
end;
(Sender as TDBedit).text:=sx;
end;

procedure T_Buchen.JournalMinusClick(Sender: TObject);
begin
euroalt:=0;
// alle evt. Buchungen im Hauptbuch dieses Buchungsvorganges lschen:
if jbnr.text<>'' then
  while k.locate('Bnr',jBnr.text,[]) do k.delete;
j.prior;
datumVorgaenger:=jDatum.Value;
j.edit;
if j.bof then with _kontoplan do
  begin
    kontoplan.DisableControls;
    showmessage('1.BUCHUNG: Salden, Journal und Konten werden gelscht.');
    belegNr:=1;
    belegTx:='';
    belegAlt:='';
  ////  datumGesichert :=18972; //strTodate('10.12.1951');
    /////datumVorgaenger:=18972;   hh2005
    kontoplan.last;
    _konto.B_pruefeClick(sender);
    _kontoplan.kontoplan.last;
    _kontoplan.suchwort.text:='';
    while not _kontoplan.kontoplan.bof and (_kontoplan.kontoplanKnr.Value<>'') do begin  //Salden lschen
      _kontoplan.kontoplan.edit;
      _kontoplan.kontoplanSaldo.text:='';
      _kontoplan.kontoplanLastAnr.Text:='';
      _kontoplan.kontoplanSeite.Text:='';
      _kontoplan.kontoplan.post;
      _kontoplan.kontoplan.prior;
    end;
    k.first;
    while not k.eof do
      k.delete;     //Hauptbuch lschen
    j.edit; sollBetrag.setfocus;
    kontoplan.EnableControls;
    showmessage('Kontoplansalden und Hauptbuch sind gelscht');
   exit;
  end;
if jok.text=GESICHERT then begin
 messageDlg('Buchung ist abgeschlossen!',mtInformation,[mbOk],0);
 j.next;
 j.edit;
end else begin
 // alle evt. Buchungen im Hauptbuch dieses Buchungsvorganges lschen:
 if jbnr.text<>'' then
   while k.locate('Bnr',jBnr.text,[]) do
     k.delete;
 // Saldo und Auszugsnummer der vorletzten Buchung lesen:
 s.edit; h.edit; u.edit;  
 k.last;
 while not k.bof and (kKnr.text<>jSollKnt.text)do k.prior;
 if not k.bof
   then begin sSaldo.value:=kSaldo.value; sLastAnr.value:=kAnr.value; end
   else begin sSaldo.text:='';            sLastAnr.text :='';         end;
 k.last;
 while not k.bof and (kKnr.text<>jHabenKnt.text)do k.prior;
 if not k.bof
   then begin hSaldo.value:=kSaldo.value; hLastAnr.value:=kAnr.value; end
   else begin hSaldo.text:='';            hLastAnr.text :='';         end;
 k.last;
 while not k.bof and (kKnr.text<>jUstKnt.text)do k.prior;
 if not k.bof
   then begin uSaldo.value:=kSaldo.value; uLastAnr.value:=kAnr.value; end
   else begin uSaldo.text:='';            uLastAnr.text :='';         end;
 s.post; h.post; u.post;
 //akltuelle BELEGBEZEICHNUNG sichern:
 belegALT:=beleg.text;
 {aktuelle Buchungszeile fr Bearbeitung freigeben: }
 j.edit;
 jok.text:=VORBEREITET;
 sollKntExit(sender);
 _journal.sucheBnr.text:=jBnr.text;
 _konto.k2.Refresh;
 _kontoplan.kontoplan.Refresh;
 _konto.EditSaldo.Text:='';
end;
end;

procedure T_Buchen.JournalEinfuegenClick(Sender: TObject);
var x : string[10];
begin
einfuegung:=true;
if jBnr.text='' then begin
  showmessage('Letzte Buchungszeile');
  exit;
  end;
if SollBetrag.text='' then begin
  showmessage('Bitte zuerst aktuelle Buchung eintragen oder Buchungszeile lschen (-)!');
  exit;
  end;
x:=SollKnt.text;
if (sTyp.text='U') then x:=SollKnt.text;
if (hTyp.text='U') then x:=HabenKnt.text;
if (sTyp.text='B') or (sTyp.text='K') then x:=SollKnt.text;
if (hTyp.text='B') or (hTyp.text='K') then x:=HabenKnt.text;
if (sTyp.text='X') then x:=SollKnt.text;
if (hTyp.text='X') then x:=HabenKnt.text;
if JournalEinfuegen.focused
  then begin j.insert; jBnr.value:=-1; end
  else j.append;  {fr JournalPlusClick}
j.edit;
Datum.text:=dateToStr(datumVorgaenger);
jSollKnt.text:=x;
jHabenKnt.text:=x;
_kontoplan.refresh;

{Auszugsnummer vorbesetzen: }
jAnr.text:='';
if (sTyp.text='B') then jAnr.value:=sLastAnr.value;
if (hTyp.text='B') then jAnr.value:=hLastAnr.value;
j.post; j.edit;
_journal.sucheBnr.text:=floatToStr(j.recNo-1);
if jBnr.text<>'' then
  Showmessage('Neue Buchungszeile wurde eingefgt. Wie gewohnt buchen.'+#10+
  'Wurde EINFGEN versehentlich geklickt, dann verwende BUCHUNGSZEILE-LSCHEN.');
end;

procedure T_Buchen.SollKntKeyPress(Sender: TObject; var Key: Char);
begin
if sollKnt.listVisible or habenKnt.listVisible then exit;
if key=#13 then begin key:=#0; postMessage(handle,WM_NextDlgCtl,0,0); end;
if (key=' ') and (sollKnt.Focused or habenKnt.focused) then begin
  key:=#0; B_sucheClick(sender);
  end;
end;

procedure T_Buchen.BelegPlusClick(Sender: TObject);
begin
beleg.setfocus;
try beleg.text:=floatToStr(belegNR+1);
except
end;
end;

procedure T_Buchen.BelegMinusClick(Sender: TObject);
begin
beleg.setfocus;
try beleg.text:=floatToStr(belegNR);
except
beleg.text:=belegTX;
end;
end;

procedure T_Buchen.B_ustClick(Sender: TObject);
var Inifile : TIniFile;
    FiamKonto, UstKonto, ZahllastKonto, UeberschussKonto : string[10];
    buchtextUst,belegnrUst : string;
    summe,ust   : Currency;
    i,fehlernummer       : byte;
const r = '                ';
begin
j.prior; datumvorgaenger:=jDatum.value; j.next; j.edit;
if messageDlg('UST Abschlubuchungen einfgen ?',mtConfirmation,
  mbOkCancel,7)=mrCancel then exit;
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
 inifile.readsection('UstKonten',listBoxUst.items);
 ZahllastKonto   :=inifile.readstring('UstAbrechnungskonten','Zahllast','');
 ueberschussKonto:=inifile.readstring('UstAbrechnungskonten','Ueberschuss','');
 fiamKonto       :=inifile.readstring('UstAbrechnungskonten','FiamVerrechnung','');
finally
 Inifile.Free;
end;
 if not (_kontoplan.kontoplan.locate('knr',zahllastKonto,[])     and
         _kontoplan.kontoplan.locate('knr',ueberschussKonto,[])  and
         _kontoplan.kontoplan.locate('knr',fiamKonto,[])       ) then begin
    showmessage('Bitte Zahllast-, berschu- und Finanzamtkonto RICHTIG einrichten !');
    exit;
    end;
 summe:=0;
 for i:=0 to listBoxUst.items.count-1 do begin
   if _kontoplan.kontoplan.locate('knr',listBoxUst.items[i],[loCaseInsensitive])
   then summe:=summe+_kontoplan.kontoplanSaldo.value
   else begin
     showmessage('Bitte UST-Konten im Fenster EINSTELLUNGEN richtig einrichten !');
     exit;
     end;
   end;
 buchtextUst:='Umsatzsteuervoranmeldung ';
 if not InputQuery('Ust Abschlu','Buchungstext',buchtextUst) then exit;
 if not InputQuery('Ust Abschlu','Belegnummer',belegnrUst) then exit;
 DatumVorgaenger:=strToDate(InputBox('Ust Abschlu','Datum',dateToStr(datumvorgaenger)));
 DruUst.clear;
 DruUst.lines.add(r+'U M S A T Z S T E U E R   V O R A N M E L D U N G');
 DruUst.lines.add('');
 DruUst.Lines.Add(r+'Mandant      : '+_init.mandant.text);
 DruUst.Lines.Add(r+'Buchungstext : '+buchtextUst);
 DruUst.Lines.Add(r+'Belegnummer  : '+belegNrUst);
 DruUst.Lines.Add(r+'Datum        : '+dateToStr(DatumVorgaenger));
 DruUst.lines.add('');
 //summe:=round(summe);     // keine Rundung seit EURO
 if summe>0
 then UstKonto:=UeberschussKonto
 else UstKonto:=ZahllastKonto;
 if (fiamKonto<>'') and (summe>0) then begin
       DruUst.Lines.Add(r+'berschu    : '+floatToStrF(summe ,ffNumber,15,2));
       j.insert;
       j.edit;
       jDatum.text:=dateToStr(datumVorgaenger);
       jbeleg.text:=belegnrUst;
       jbuchtext.text:=buchtextUst;
       jBnr.value        :=-2;
       jHabenKnt.text    :=UstKonto;
       jSollKnt .text    :=fiamKonto;
       jsollBetrag .value:=summe;
       jhabenBetrag.value:=summe;
       j.post; j.edit;
       end
  else begin
       DruUst.Lines.Add(r+'Vorauszahlung(-): '+floatToStrF(summe ,ffNumber,15,2));
       j.insert;
       j.edit;
       jDatum.text:=dateToStr(datumVorgaenger);
       jbeleg.text:=belegnrUst;
       jbuchtext.text:=buchtextUst;
       jBnr.value        :=-2;
       jHabenKnt.text    :=fiamKonto;
       jSollKnt .text    :=UstKonto;
       jsollBetrag .value:=abs(summe);
       jhabenBetrag.value:=abs(summe);
       j.post; j.edit;
   end;
DruUst.lines.add('');
for i:=0 to listBoxUst.items.count-1 do try
     _kontoplan.kontoplan.DisableControls;
     fehlernummer:=0;
     with _kontoplan do begin
       kontoplan.locate('ustKnt',listBoxUst.items[i],[]);
       ust:=kontoplanUstP.value;
       repeat
         if (kontoplanUstKnt.text=listBoxUst.items[i]) then
           if ust<>kontoplanUstP.value then ust:=0;  {gemischter Ust Satz (Vorst)}
         try if strtoint(copy(kontoplanUstKnt.text,4,2))<>kontoplanUstP.Value then inc(fehlernummer);
         except
         end;
         kontoplan.next;
       until kontoplan.eof;
       ust:=ust/100;
     end;
     _kontoplan.kontoplan.locate('knr',listBoxUst.items[i],[loCaseinsensitive]);
     if _kontoplan.kontoplanSaldo.value<0 then begin
       j.insert;
       j.edit;
       jDatum.text:=dateToStr(datumVorgaenger);
       jbeleg.text:=belegnrUst;
       jbuchtext.text:=buchtextUst;
       jBnr.value        :=-2;
       jSollKnt .text    :=listBoxUst.items[i];
       jHabenKnt.text    :=UstKonto;
       jsollBetrag .value:=abs(sSaldo.value);
       jhabenBetrag.value:=abs(sSaldo.value);
       j.post; j.edit;
       if ust=0
         then DruUst.Lines.Add(r+listBoxUst.items[i]+' =  . . . . . . . . . . '
              +floatToStr(sSaldo.value))
         else DruUst.Lines.Add(r+listBoxUst.items[i]+' = '
              +floatToStr(sSaldo.value/ust)
              +'   -->    '
              +floatToStrF(sSaldo.value,ffnumber,15,2));
       end
     else if _kontoplan.kontoplanSaldo.value>=0 then begin
       j.insert;
       j.edit;
       jDatum.text:=dateToStr(datumVorgaenger);
       jbeleg.text:=belegnrUst;
       jbuchtext.text:=buchtextUst;
       jBnr.value        :=-2;
       jHabenKnt.text    :=listBoxUst.items[i];
       jSollKnt .text    :=UstKonto;
       jsollBetrag .value:=abs(hSaldo.value);
       jhabenBetrag.value:=abs(hSaldo.value);
       j.post; j.edit;
       if ust=0
         then DruUst.Lines.Add(r+listBoxUst.items[i]+' =  . . . . . . . . . . '
              +floatToStr(hSaldo.value))
         else DruUst.Lines.Add(r+listBoxUst.items[i]+' = '
              +floatToStr(hSaldo.value/ust)
              +'    -+>    '
              +floatToStrF(hSaldo.value ,ffNumber,15,2));
       end;
    _kontoplan.kontoplan.EnableControls;
except
  showmessage('Fehler bei UST-Berechnung');
end;
 j.post; j.edit;      
 _journal.sucheBnr.text:=floatToStr(j.recNo-1);
 if fehlernummer>0 then showmessage(inttostr(fehlernummer)
 +' FEHLER bei UST% Zuordnung im Kontoplan (Ust-Konto ungleich UstP oder Ust-Konto unleich UST..) ');
 DruUst.print('Ust Voranmeldung');
 druUst.Lines.SaveToFile('ustmeldung.txt');
 druUst.Lines.SaveToFile('ustmeldung'+inttostr(monthof(datumvorgaenger))+'.txt');
 showmessage('Beleg fr UST-Voranmeldung auch in der Datei "UstMeldung'+inttostr(monthof(datumvorgaenger))+'.txt" gespeichert');
end;

procedure T_Buchen.OkClick(Sender: TObject);
var s1,h1, s2,h2 : Currency;
    inifile:Tinifile;
begin
if _journal.jok.text<>_buchen.jok.text then _buchen.journalplusClick(sender);
s1:=0; h1:=0; s2:=0; h2:=0;
with _journal do try
  j.DisableControls;
  j.first;  k.first;
  while not j.eof and ( (jok.text=GESICHERT) or (jOk.text=GEBUCHT) ) do begin
    s1:=s1+jSollBetrag.value+jUstSoll.value;
    h1:=h1+jHabenBetrag.value+jUstHaben.value;
    j.next;
  end;
  while not (k.eof) do begin
    s2:=s2+kSollBetrag.value;
    h2:=h2+kHabenBetrag.value;
    k.next;
  end;
finally
  j.EnableControls;
end;
if (s1<>s2) or (h1<>h2) or (s1<>h1)
  then showmessage('FEHLER: SOLL/HABEN ungleich oder JOURNAL ungleich KONTO !!')
  else ;//showmessage('JOURNAL und KONTO geprft und OK = '+floatToStr(s1));
s1:=jbnr.value;
if ok.tag=0 then exit; //----------------->
if InputBox('Buchungsschutz aufheben','Passwort "Buchungsschutz aufheben"','')
   ='FINANZAMT'
   then begin
    j.DisableControls;
    screen.cursor:=crHourglass;
    try
     datumGesichert:=1;
     j.first; j.edit;
     repeat
       if jOk.text=GESICHERT then jOk.text:=gebucht;
       j.next; j.edit;
       until j.eof or (s1=jbnr.value);
     finally
      screen.cursor:=crDefault;
      j.enableControls;
     end;
     //Sichern
      Inifile:= TIniFile.Create('.\HuBH.Ini');
      try
        Inifile.writestring('Datum','Geschuetzt',dateToStr(datumGesichert));
      finally
       Inifile.Free;
      end;
     //ende
   end;
end;

procedure T_Buchen.BetragPlusClick(Sender: TObject);
begin
if (_Konto.k2sollbetrag.value>0) then begin
  sollbetrag.setfocus;
  jsollbetrag.value:=_Konto.k2sollbetrag.value
end else begin
  habenbetrag.setfocus;
  jhabenbetrag.value:=_Konto.k2habenbetrag.value;
end;
jbuchtext.Value:=_Konto.k2buchtext.Value;
end;

procedure T_Buchen.SucheKontoClick(Sender: TObject);
begin
_kontoplan.kontoplan.DisableControls;
try
  if _Kontoplan.kontoplan.bof then begin
    _Kontoplan.kontoplan.last;
    showmessage('Dateiende');
  end;
  repeat _kontoplan.kontoplan.prior;
  until _kontoplan.kontoplan.bof
        or (pos(suchWort,ansiuppercase(_kontoplan.kontoplanName.text))>0)
        or (pos(suchWort,ansiuppercase(_kontoplan.kontoplanKnr.text))>0);
  _journal.SucheText.text:=suchwort;
  if _kontoplan.kontoplan.bof then begin
    showmessage('"'+suchwort+
       '" im Kontoplan nicht gefunden. Suche an JOURNAL bergeben.');
    _journal.sucheLastClick(sender);
    end;
  if sollknt.focused  then jsollKnt.text:=_kontoplan.kontoplanKnr.text;
  if habenknt.focused then jhabenKnt.text:=_kontoplan.kontoplanKnr.text;
finally
  _kontoplan.kontoplan.EnableControls;
end;
end;

procedure T_Buchen.B_sucheClick(Sender: TObject);
begin
  _kontoplan.kontoplan.last;
  suchwort:=ansiuppercase(inputbox('Sollkonto','Suchbegriff',suchwort));
  sucheKontoClick(sender);
end;

procedure T_Buchen.BelegKeyPress(Sender: TObject; var Key: Char);
begin
case key of
  '+' : begin BelegPlusClick(sender);  key:=#0; end;
  '-' : begin BelegMinusClick(sender); key:=#0; end;
  '#' : begin L_BelegClick(sender); key:=#0; end;
  #13 : begin key:=#0; postMessage(handle,WM_NextDlgCtl,0,0); end;
  end;
end;

procedure T_Buchen.BuchtextEnter(Sender: TObject);
begin
if (sollknt.text='') or (habenknt.Text='') then begin
  buchtext.Text:='';
  sollKnt.SetFocus;
  exit;
end;
//Buchungstext mit Kontoberschrift vorbesetzen:
if sollknt.Text=habenknt.Text then jBuchtext.text:=''
else begin
 if (jBuchtext.text='') and _init.autoinsert.checked then
   if hTyp.text[1]in ['A','E']               //2008 vorher auch ,'U'
     then jBuchtext.text:=hname.text
     else if sTyp.text[1]in ['A','E','U']
       then jBuchtext.text:=sname.text
       else jBuchtext.text:=sname.text;
end;
jBuchtext.text:=copy(jBuchtext.text,pos(':',jBuchtext.text)+1,9999);
Buchtext.SelStart:=0;
Buchtext.SelLength:=999;
end;

procedure T_Buchen.B_2ATSClick(Sender: TObject);
begin
if euroAlt=0 then begin
  euroAlt:=jHabenbetrag.value;
  if jHabenbetrag.value=jSollBetrag.value
    then originalbetrag:='['
    else originalbetrag:='['+jSollbetrag.text+'eu';
  originalbetrag:=originalbetrag+jHabenbetrag.text+']';
  jBuchtext.text:=originalbetrag+' '+jBuchtext.text;
  end
  else jHabenbetrag.value:=euroAlt;
jHabenbetrag.value:=jHabenbetrag.value*strToFloat(_init.euroKurs.text);
habenbetragExit(sender);
end;

procedure T_Buchen.B_2EUROClick(Sender: TObject);
begin
if euroAlt=0 then begin
  euroAlt:=jHabenbetrag.value;
  if jHabenbetrag.value=jSollBetrag.value
    then originalbetrag:='['
    else originalbetrag:='['+jSollbetrag.text+'s';
  originalbetrag:=originalbetrag+jHabenbetrag.text+']';
  jBuchtext.text:=originalbetrag+' '+jBuchtext.text;
  end
  else jHabenbetrag.value:=euroAlt;
jHabenbetrag.value:=jHabenbetrag.value/strToFloat(_init.eurokurs.text);
habenbetragExit(sender);
end;

procedure T_Buchen.FormDeactivate(Sender: TObject);
begin
sollkntExit(sender);
end;

procedure T_Buchen.B_StoVorlageClick(Sender: TObject);
begin
if buchtext.Items.IndexOf(buchtext.text)=-1 then buchtext.Items.add(buchtext.text);
buchtext.items.SaveToFile('vorlagen.txt');
buchtext.SetFocus;
end;

procedure T_Buchen.ScrollBoxDblClick(Sender: TObject);
begin
_konto.windowstate:=wsNormal;
_konto.fixeKontowahl.checked:=false;
if _kontoplan.suchwort.text=jSollKnt.text
then _kontoplan.suchwort.text:=jHabenKnt.text
else _kontoplan.suchwort.text:=jSollKnt.text;
end;

procedure T_Buchen.FormDestroy(Sender: TObject);
var Inifile: TIniFile;
begin
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
  inifile.writestring ('DATEN','BelegTX' ,belegTX);
  inifile.writestring ('DATEN','BelegALT',belegALT);
  inifile.writeinteger('DATEN','BelegNR' ,belegNR);
  inifile.writeinteger('DATEN','AnrNR' ,AnrNR);
finally
  Inifile.Free;
end;
end;

procedure T_Buchen.B_BelegALTClick(Sender: TObject);
begin
beleg.text:=belegALT;
end;

procedure T_Buchen.SollBetragEnter(Sender: TObject);
begin
euroalt:=0;
end;

procedure T_Buchen.Button1Click(Sender: TObject);
begin
if euroAlt<>0 then begin
jHabenbetrag.value:=euroAlt;
habenbetragExit(sender);
end;
end;

procedure T_Buchen.BuchtextChange(Sender: TObject);
begin
if length(buchtext.text)>45
  then buchtext.Color:=clyellow
  else buchtext.Color:=claqua;
end;

procedure T_Buchen.beleganzeige(bn:string);
var  //uses ShellAPI;
  zFileName, zParams, zDir: array[0..79] of Char;
  pfad:string;
begin
GetDir(0,pfad);  pfad:=pfad+'\belege\';
if length(bn)=0
then showmessage('Erstelle Beleg im "Arbeitsverzeichnis\BELEGE\" mit '+
  'beliebiger Dateierweiterung. Vorzugsweise aber PDF, JPG, SXW, SXC, DOC, ODT, XLS, TXT')
else begin
  if pos('.',bn)>0  then begin
    StrPCopy(zFileName,pfad+bn);
    ShellExecute(Application.MainForm.Handle, nil,zFileName,
      StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	);
  end else begin
    StrPCopy(zFileName,pfad+bn+'.jpg');
    if ShellExecute(Application.MainForm.Handle, nil,zFileName,
      StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	) <33
    then begin
      StrPCopy(zFileName,pfad+bn+'.sxw');
      if ShellExecute(Application.MainForm.Handle, nil,zFileName,
        StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	) <33
        then begin
        StrPCopy(zFileName,pfad+bn+'.sxc');
        if ShellExecute(Application.MainForm.Handle, nil,zFileName,
          StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	) <33
        then begin
          StrPCopy(zFileName,pfad+bn+'.doc');
          if ShellExecute(Application.MainForm.Handle, nil,zFileName,
            StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	) <33
          then begin
            StrPCopy(zFileName,pfad+bn+'.xls');

            if ShellExecute(Application.MainForm.Handle, nil,zFileName,
              StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	) <33
            then begin
              StrPCopy(zFileName,pfad+bn+'.odt');

              if ShellExecute(Application.MainForm.Handle, nil,zFileName,
               StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	) <33
              then begin
                StrPCopy(zFileName,pfad+bn+'.pdf');
                if ShellExecute(Application.MainForm.Handle, nil,zFileName,
                 StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	) <33
                then begin
                  StrPCopy(zFileName,pfad+bn+'.txt');
                  if ShellExecute(Application.MainForm.Handle, nil,zFileName,
                   StrPCopy(zParams,''),StrPCopy(zDir,''), SW_SHOWDEFAULT	) <33
                  then showmessage(
                  'Vermutlich Anwendungsprogramm oder "'+zFilename+'" nicht vorhanden '+
                  '(.PDF, JPG, SXW, SXC, DOC, ODT, XLS, TXT)');
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;
end;

procedure T_Buchen.L_belegClick(Sender: TObject);
begin
beleganzeige(beleg.Text);
end;

procedure T_Buchen.sollNameDblClick(Sender: TObject);
begin
buchtext.Text:=sollname.Text;
end;

procedure T_Buchen.habenNameDblClick(Sender: TObject);
begin
buchtext.Text:=habenname.Text;
end;

procedure T_Buchen.B_delVorlageClick(Sender: TObject);
begin
buchtext.DeleteSelected;
buchtext.Repaint;
buchtext.items.SaveToFile('vorlagen.txt');
buchtext.setfocus;
end;

procedure T_Buchen.BelegDblClick(Sender: TObject);
begin
if opendialog1.Execute then beleg.Text:=extractFileName(opendialog1.FileName);
if pos('.pdf',beleg.text)>0 then beleg.Text:=copy(beleg.Text,1,pos('.pdf',beleg.text)-1);
if pos('.doc',beleg.text)>0 then beleg.Text:=copy(beleg.Text,1,pos('.doc',beleg.text)-1);
if pos('.sxw',beleg.text)>0 then beleg.Text:=copy(beleg.Text,1,pos('.sxw',beleg.text)-1);
if pos('.sxc',beleg.text)>0 then beleg.Text:=copy(beleg.Text,1,pos('.sxc',beleg.text)-1);
if pos('.xls',beleg.text)>0 then beleg.Text:=copy(beleg.Text,1,pos('.xls',beleg.text)-1);
if pos('.jpg',beleg.text)>0 then beleg.Text:=copy(beleg.Text,1,pos('.jpg',beleg.text)-1);
if pos('.txt',beleg.text)>0 then beleg.Text:=copy(beleg.Text,1,pos('.txt',beleg.text)-1);
end;

procedure T_Buchen.meldungEnter(Sender: TObject);
begin
journalplus.SetFocus;
end;

end.

