unit bhed_1st;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, DBTables, Db, ExtCtrls, DBCtrls, ToolWin,
  Grids, DBGrids, Menus;

type
  T_Main = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    edit: TCheckBox;
    Label1: TLabel;
    Session1: TSession;
    BitBtn3: TBitBtn;
    ag: TRichEdit;
    MainMenu1: TMainMenu;
    Bearbeiten1: TMenuItem;
    knr2uppercase: TMenuItem;
    kp1: TTable;
    DS1: TDataSource;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    kp1Knr: TStringField;
    kp1Typ: TStringField;
    kp1Name: TStringField;
    kp1UstKnt: TStringField;
    kp1UstP: TSmallintField;
    kp1Saldo: TBCDField;
    kp1Budget: TBCDField;
    kp1Gruppe: TStringField;
    kp1LastAnr: TSmallintField;
    kp1Seite: TSmallintField;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure editClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure knr2uppercaseClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    gruppe : string[4];
    hbnr   : string[12];
  public
    { Public-Deklarationen }
  end;

var
  _Main: T_Main;

implementation

uses bhed_kp, bhed_j;

{$R *.DFM}

procedure T_Main.BitBtn1Click(Sender: TObject);
begin
_kontoplan.Show;
end;

procedure T_Main.BitBtn2Click(Sender: TObject);
begin
_Journal.show;
end;

procedure T_Main.FormCreate(Sender: TObject);
var s:string;
begin
GetDir(0,s);
caption:='HuBH-View ('+s+')';
session1.addpassword('hubsi');
try
 memo1.Lines.LoadFromFile('hubhimport.csv');
except
 button2.Enabled:=false;
end;
end;

procedure T_Main.editClick(Sender: TObject);
begin
_kontoplan.DS1.autoedit:=edit.Checked;
_journal.DS1.autoedit:=edit.Checked;
end;

procedure T_Main.BitBtn3Click(Sender: TObject);
begin
with _Journal, _Kontoplan do begin
j.disablecontrols;
kp.disablecontrols;
try
j.first;
ag.lines.Append
(' bnr'        +#9+' gru'        +#9+' HauptbuchNr'  +#9+' SollKnt  '   +#9
+' HabenKnt '  +#9+' UstKnt   '  +#9+' U%'           +#9+' Sollbetrag ' +#9
+' Habenbetrag'+#9+' UstSoll    '+#9+' UstHaben   '  +#9+' AuszugNr '   +#9
+' BelegNr  '  +#9+' Datum    '  +#9+' SollSaldo  '  +#9+' Habensaldo ' +#9
+' UstSaldo   '+#9+' ok'         +#9+' Buchungstext');
while not J.eof do begin
  if Jsollknt.text<Jhabenknt.text then begin
    hbnr:=Jsollknt.text;
    if _kontoplan.kp.locate('knr',Jsollknt.text,[])
      then gruppe:=_kontoplan.KPgruppe.text
      else gruppe:='?';
  end else begin
    hbnr:=Jhabenknt.text;
    if _kontoplan.kp.locate('knr',Jhabenknt.text,[])
      then gruppe:=_kontoplan.KPgruppe.text
      else gruppe:='?';
  end;
  ag.lines.Append(format
    ('%-4s' +#9+'%-4s' +#9+'%-12s'+#9+'%-10s'+#9
    +'%-10s'+#9+'%-10s'+#9+'%3s'  +#9+'%12s' +#9
    +'%12s' +#9+'%12s' +#9+'%12s' +#9+'%-10s' +#9
    +'%-10s' +#9+'%-10s' +#9+'%12s' +#9+'%12s' +#9
    +'%12s' +#9+'%-3s'  +#9+'%-12s',
    [Jbnr.text,        gruppe,       hbnr,            Jsollknt.text,
     Jhabenknt.text,   Justknt.text, JustP.text,      Jsollbetrag.text,
     JHabenbetrag.text,JustSoll.text,JUstHaben.text,  JAnr.text,
     JBeleg.text,      JDatum.text,  JSollSaldo2.text,JHabensaldo2.text,
     JUstSaldo2.text,  Jok.text,     JBuchtext.text
    ]));
  j.next;
  end;
J.first;
while not J.eof do begin
  if Jsollknt.text>=Jhabenknt.text then begin
    hbnr:=Jsollknt.text+'*';
    if _kontoplan.kp.locate('knr',Jsollknt.text,[])
      then gruppe:=_kontoplan.KPgruppe.text
      else gruppe:='?';
  end else begin
    hbnr:=Jhabenknt.text+'*';
    if _kontoplan.kp.locate('knr',Jhabenknt.text,[])
      then gruppe:=_kontoplan.KPgruppe.text
      else gruppe:='?';
  end;
  ag.lines.Append(format
    ('%-4s' +#9+'%-4s' +#9+'%-12s'+#9+'%-10s'+#9
    +'%-10s'+#9+'%-10s'+#9+'%3s'  +#9+'%12s' +#9
    +'%12s' +#9+'%12s' +#9+'%12s' +#9+'%-10s' +#9
    +'%-10s' +#9+'%-10s' +#9+'%12s' +#9+'%12s' +#9
    +'%12s' +#9+'%-3s'  +#9+'%-12s',
    [Jbnr.text,        gruppe,       hbnr,            Jsollknt.text,
     Jhabenknt.text,   Justknt.text, JustP.text,      Jsollbetrag.text,
     JHabenbetrag.text,JustSoll.text,JUstHaben.text,  JAnr.text,
     JBeleg.text,      JDatum.text,  JSollSaldo2.text,JHabensaldo2.text,
     JUstSaldo2.text,  Jok.text,     JBuchtext.text
    ]));
  j.next;
  end;
ag.lines.SaveToFile('journal.txt');
finally
j.enablecontrols;
kp.enablecontrols;
end;
end;
end;

procedure T_Main.knr2uppercaseClick(Sender: TObject);
begin
kp1.open;
repeat
  try
  kp1.edit;
  kp1Knr.text:=ansiuppercase(kp1Knr.text);
  kp1.next;
  except
  showmessage('"'+kp1Knr.text+'" vermutlich doppelt. Bitte Lschen!');
  kp1.cancel;
  kp1.next;
  end;
until kp1.eof;
showmessage('Kontonummern sind nun in Grobuchstaben');
kp1.Close;
end;

procedure T_Main.Button1Click(Sender: TObject);
var x:real;
begin
x:=0;
with _kontoplan do begin
  while not kp.Eof do begin
    x:=x+abs(kpSaldo.value);
    kp.next;
  end;
  if x=0 then begin
    kpKnr.ReadOnly:=false;
    kpTyp.ReadOnly:=false;
    kpUstp.ReadOnly:=false;
    kpUstknt.ReadOnly:=false;
    kpSeite.ReadOnly:=false;
    kpSaldo.ReadOnly:=false;
    kpLastanr.ReadOnly:=false;
  end else showmessage('EDIT nicht erlaubt, da Saldo ungleich 0');
end;
_kontoplan.Show;
end;

procedure T_Main.Button2Click(Sender: TObject);
var i:integer;
begin
for i:=0 to memo1.lines.Count-1 do begin
 try
   kp1.Insert;
   kp1knr.Value:=copy(memo1.Lines[i],1,pos(',',memo1.Lines[i])-1);
   kp1typ.Value:='A';
   kp1name.Value:=copy(memo1.Lines[i],pos(',',memo1.Lines[i])+1,99);
   kp1.Post;
 except
 end;
end;
showmessage('ok');
end;

end.


