unit HuFIAM1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, clipbrd, Buttons, OleCtrls, SHDocVw;

type
  T_huFiam = class(TForm)
    B_create: TButton;
    vonJahr: TSpinEdit;
    vonMonat: TSpinEdit;
    Quartal: TCheckBox;
    kz000: TLabeledEdit;
    kz001: TLabeledEdit;
    kz021: TLabeledEdit;
    kz011: TLabeledEdit;
    kz016: TLabeledEdit;
    kz015: TLabeledEdit;
    kz012: TLabeledEdit;
    kz017: TLabeledEdit;
    kz018: TLabeledEdit;
    kz029: TLabeledEdit;
    kz025: TLabeledEdit;
    kz022: TLabeledEdit;
    kz020: TLabeledEdit;
    kz019: TLabeledEdit;
    kz070: TLabeledEdit;
    kz048: TLabeledEdit;
    kz057: TLabeledEdit;
    kz056: TLabeledEdit;
    kz038: TLabeledEdit;
    kz052: TLabeledEdit;
    kz035: TLabeledEdit;
    kz063: TLabeledEdit;
    kz077: TLabeledEdit;
    kz076: TLabeledEdit;
    kz075: TLabeledEdit;
    kz073: TLabeledEdit;
    kz072: TLabeledEdit;
    kz071: TLabeledEdit;
    kz065: TLabeledEdit;
    kz083: TLabeledEdit;
    kz061: TLabeledEdit;
    kz060: TLabeledEdit;
    kz067: TLabeledEdit;
    kz062: TLabeledEdit;
    kz064: TLabeledEdit;
    kz082: TLabeledEdit;
    kz066: TLabeledEdit;
    kz090: TLabeledEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    are: TCheckBox;
    repo: TCheckBox;
    vst: TLabeledEdit;
    tx: TMemo;
    zahllast_gutschrift: TLabeledEdit;
    teilnehmernummer: TEdit;
    Edit2: TEdit;
    B_internet: TBitBtn;
    txid: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    txstnr: TEdit;
    Label16: TLabel;
    Edit1: TEdit;
    Label17: TLabel;
    Label13: TLabel;
    procedure B_createClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure B_internetClick(Sender: TObject);
    procedure kz022Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  _huFiam : T_huFiam;
  id    : string[9] = '271759508';
  stnr  : string[6] = '9508';
  datum : string[10];
  zeit  : string[8];


implementation

uses huFiam2;

{$R *.dfm}

procedure T_huFiam.B_createClick(Sender: TObject);
var yy,mm,tt,st,mi,se,hs:word;
    x:byte;
    txt:string[1];
begin
id:=txid.Text;
stnr:=txstnr.Text;
if (vonMonat.Text='2') or (vonMonat.text='3') then vonMonat.Text:='1';
if (vonMonat.Text='5') or (vonMonat.text='6') then vonMonat.Text:='4';
if (vonMonat.Text='8') or (vonMonat.text='9') then vonMonat.Text:='7';
if (vonMonat.Text='11') or (vonMonat.text='12') then vonMonat.Text:='10';
decodedate(date,yy,mm,tt);
decodetime(now,st,mi,se,hs);
datum:=format('%4.4d-%2.2d-%2.2d',[yy,mm,tt]);
zeit:=format('%2.2d:%2.2d:%2.2d',[st,mi,se]);
tx.Clear;
tx.Lines.Add('<?xml version="1.0" encoding="iso-8859-1"?>');
tx.Lines.Add('<ERKLAERUNGS_UEBERMITTLUNG>');
tx.Lines.Add('<INFO_DATEN>');
tx.Lines.Add('<ART_IDENTIFIKATIONSBEGRIFF>FASTNR</ART_IDENTIFIKATIONSBEGRIFF>');
tx.Lines.Add('<IDENTIFIKATIONSBEGRIFF>'+id+'</IDENTIFIKATIONSBEGRIFF>');
tx.Lines.Add('<PAKET_NR>1</PAKET_NR>');
tx.Lines.Add('<DATUM_ERSTELLUNG type="datum">'+datum+'</DATUM_ERSTELLUNG>');
tx.Lines.Add('<UHRZEIT_ERSTELLUNG type="uhrzeit">'+zeit+'</UHRZEIT_ERSTELLUNG>');
tx.Lines.Add('<ANZAHL_ERKLAERUNGEN>1</ANZAHL_ERKLAERUNGEN>');
tx.Lines.Add('</INFO_DATEN>');
tx.Lines.Add('<ERKLAERUNG art="U30">');
tx.Lines.Add('<SATZNR>1</SATZNR>');
tx.Lines.Add('<ALLGEMEINE_DATEN>');
tx.Lines.Add('<ANBRINGEN>U30</ANBRINGEN>');
tx.Lines.Add('<ZRVON type="jahrmonat">'+
             vonJahr.Text+'-'+format('%2.2d',[vonMonat.value])+'</ZRVON>');
if quartal.Checked then x:=2 else x:=0;
tx.Lines.Add('<ZRBIS type="jahrmonat">'+
             vonJahr.Text+'-'+format('%2.2d',[vonMonat.value+x])+'</ZRBIS>');
tx.Lines.Add('<FASTNR>'+id+'</FASTNR>');
tx.Lines.Add('<KUNDENINFO>HuBH UVA</KUNDENINFO>');
tx.Lines.Add('</ALLGEMEINE_DATEN>');
tx.Lines.Add('<LIEFERUNGEN_LEISTUNGEN_EIGENVERBRAUCH>');
tx.Lines.Add('<KZ000 type="kz">'+kz000.text+'</KZ000>');
tx.Lines.Add('<KZ001 type="kz">'+kz001.text+'</KZ001>');
tx.Lines.Add('<KZ021 type="kz">'+kz021.text+'</KZ021>');
tx.Lines.Add('<STEUERFREI>');
tx.Lines.Add('<KZ011 type="kz">'+kz011.text+'</KZ011>');
tx.Lines.Add('<KZ012 type="kz">'+kz012.text+'</KZ012>');
tx.Lines.Add('<KZ015 type="kz">'+kz015.text+'</KZ015>');
tx.Lines.Add('<KZ017 type="kz">'+kz017.text+'</KZ017>');
tx.Lines.Add('<KZ018 type="kz">'+kz018.text+'</KZ018>');
tx.Lines.Add('<KZ019 type="kz">'+kz019.text+'</KZ019>');
tx.Lines.Add('<KZ016 type="kz">'+kz016.text+'</KZ016>');
tx.Lines.Add('<VST>'+vst.Text+'</VST>');
tx.Lines.Add('<KZ020 type="kz">'+kz020.text+'</KZ020>');
tx.Lines.Add('</STEUERFREI>');
tx.Lines.Add('<VERSTEUERT>');
tx.Lines.Add('<KZ022 type="kz">'+kz022.text+'</KZ022>');
tx.Lines.Add('<KZ029 type="kz">'+kz029.text+'</KZ029>');
tx.Lines.Add('<KZ025 type="kz">'+kz025.text+'</KZ025>');
tx.Lines.Add('<KZ035 type="kz">'+kz035.text+'</KZ035>');
tx.Lines.Add('<KZ052 type="kz">'+kz052.text+'</KZ052>');
tx.Lines.Add('<KZ038 type="kz">'+kz038.text+'</KZ038>');
tx.Lines.Add('<KZ056 type="kz">'+kz056.text+'</KZ056>');
tx.Lines.Add('<KZ057 type="kz">'+kz057.text+'</KZ057>');
tx.Lines.Add('<KZ048 type="kz">'+kz048.text+'</KZ048>');
tx.Lines.Add('</VERSTEUERT>');
tx.Lines.Add('</LIEFERUNGEN_LEISTUNGEN_EIGENVERBRAUCH>');
tx.Lines.Add('<INNERGEMEINSCHAFTLICHE_ERWERBE>');
tx.Lines.Add('<KZ070 type="kz">'+kz070.text+'</KZ070>');
tx.Lines.Add('<KZ071 type="kz">'+kz071.text+'</KZ071>');
tx.Lines.Add('<VERSTEUERT_IGE>');
tx.Lines.Add('<KZ072 type="kz">'+kz072.text+'</KZ072>');
tx.Lines.Add('<KZ073 type="kz">'+kz073.text+'</KZ073>');
tx.Lines.Add('<KZ075 type="kz">'+kz075.text+'</KZ075>');
tx.Lines.Add('<KZ076 type="kz">'+kz076.text+'</KZ076>');
tx.Lines.Add('<KZ077 type="kz">'+kz077.text+'</KZ077>');
tx.Lines.Add('</VERSTEUERT_IGE>');
tx.Lines.Add('</INNERGEMEINSCHAFTLICHE_ERWERBE>');
tx.Lines.Add('<VORSTEUER>');
tx.Lines.Add('<KZ060 type="kz">'+kz060.text+'</KZ060>');
tx.Lines.Add('<KZ061 type="kz">'+kz061.text+'</KZ061>');
tx.Lines.Add('<KZ083 type="kz">'+kz083.text+'</KZ083>');
tx.Lines.Add('<KZ065 type="kz">'+kz065.text+'</KZ065>');
tx.Lines.Add('<KZ066 type="kz">'+kz066.text+'</KZ066>');
tx.Lines.Add('<KZ082 type="kz">'+kz082.text+'</KZ082>');
tx.Lines.Add('<KZ064 type="kz">'+kz064.text+'</KZ064>');
tx.Lines.Add('<KZ062 type="kz">'+kz062.text+'</KZ062>');
tx.Lines.Add('<KZ063 type="kz">'+kz063.text+'</KZ063>');
tx.Lines.Add('<KZ067 type="kz">'+kz067.text+'</KZ067>');
tx.Lines.Add('<KZ090 type="kz">'+kz090.text+'</KZ090>');
if are.Checked then txt:='J' else txt:='N';
tx.Lines.Add('<ARE>'+txt+'</ARE>');
if repo.Checked then txt:='J' else txt:='N';
tx.Lines.Add('<REPO>'+txt+'</REPO>');
tx.Lines.Add('</VORSTEUER>');
tx.Lines.Add('</ERKLAERUNG>');
tx.Lines.Add('</ERKLAERUNGS_UEBERMITTLUNG>');
tx.Lines.SaveToFile('c:\xuva.xml');
end;

procedure T_huFiam.FormCreate(Sender: TObject);
begin
if ParamCount=4 then begin
  vonmonat.Text:=ParamStr(1);
  kz022.Text:=ParamStr(2);
  kz029.Text:=ParamStr(3);
  kz060.Text:=ParamStr(4);
  Clipboard.AsText:=teilnehmernummer.text;
end else begin
  tx.Lines.LoadFromFile('c:\xuva.xml');
  kz022.Text:=copy(tx.text,pos('<KZ022 type="kz">',tx.text)+17,pos('</KZ022>',tx.text)-pos('<KZ022 type="kz">',tx.text)-17);
  kz029.Text:=copy(tx.text,pos('<KZ029 type="kz">',tx.text)+17,pos('</KZ029>',tx.text)-pos('<KZ029 type="kz">',tx.text)-17);
  kz025.Text:=copy(tx.text,pos('<KZ025 type="kz">',tx.text)+17,pos('</KZ025>',tx.text)-pos('<KZ025 type="kz">',tx.text)-17);
  kz035.Text:=copy(tx.text,pos('<KZ035 type="kz">',tx.text)+17,pos('</KZ035>',tx.text)-pos('<KZ035 type="kz">',tx.text)-17);
  kz052.Text:=copy(tx.text,pos('<KZ052 type="kz">',tx.text)+17,pos('</KZ052>',tx.text)-pos('<KZ052 type="kz">',tx.text)-17);
  kz038.Text:=copy(tx.text,pos('<KZ038 type="kz">',tx.text)+17,pos('</KZ038>',tx.text)-pos('<KZ038 type="kz">',tx.text)-17);
  kz060.Text:=copy(tx.text,pos('<KZ060 type="kz">',tx.text)+17,pos('</KZ060>',tx.text)-pos('<KZ060 type="kz">',tx.text)-17);
end;
end;

procedure T_huFiam.B_internetClick(Sender: TObject);
begin
B_createClick(sender);
Clipboard.AsText:=teilnehmernummer.text;
_ie.showmodal;
end;

procedure T_huFiam.kz022Change(Sender: TObject);
begin
try
kz000.Text:=inttostr(
  strtoint(kz022.Text)+
  strtoint(kz029.Text)+
  strtoint(kz025.Text)+
  strtoint(kz035.Text)+
  strtoint(kz052.Text)+
  strtoint(kz038.Text)
  );
except
end;
end;

procedure T_huFiam.Button1Click(Sender: TObject);
begin
nd;

end.
