unit bh_main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, inifiles,db,
  DdeMan, OleCtnrs, DBTables, QRExport, variants, dateutils;

type
  T_HuBH = class(TForm)
    MainMenu1: TMainMenu;
    Window1: TMenuItem;
    Help1: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    Speichern: TMenuItem;
    Hilfethemen1: TMenuItem;
    SpeedPanel: TPanel;
    OpenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    CutBtn: TSpeedButton;
    CopyBtn: TSpeedButton;
    PasteBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    Laden: TMenuItem;
    groesser: TMenuItem;
    Datei1: TMenuItem;
    NeuerMandant1: TMenuItem;
    Beenden1: TMenuItem;
    Druck1: TMenuItem;
    AlleKonten1: TMenuItem;
    Journal1: TMenuItem;
    Rohbilanz1: TMenuItem;
    Kontoplan1: TMenuItem;
    Einzelkonto1: TMenuItem;
    Gruppensummen: TMenuItem;
    Gruppenplan: TMenuItem;
    Tabelle: TTable;
    J1: TTable;
    DSj1: TDataSource;
    J1SollKnt: TStringField;
    J1HabenKnt: TStringField;
    J1SollBetrag: TBCDField;
    J1HabenBetrag: TBCDField;
    J1Ok: TStringField;
    J1Datum: TDateField;
    J1Buchtext: TStringField;
    Beleg1: TMenuItem;
    QRTextFilter1: TQRTextFilter;
    BhInfodocbearbeiten1: TMenuItem;
    N1: TMenuItem;
    Rohbilanz2: TMenuItem;
    Budgetuebersicht: TMenuItem;
    GruppemplanRest: TMenuItem;
    GruppensummenundRest1: TMenuItem;
    Gruppenplan23Test1: TMenuItem;
    HauptbuchExport1: TMenuItem;
    ag: TMemo;
    SLKupdate1: TMenuItem;
    knt1plan: TTable;
    knt1planKNR: TStringField;
    knt1planTYP: TStringField;
    knt1planNAME: TStringField;
    knt1planSALDO: TFloatField;
    knt1planBUDGET: TFloatField;
    knt1planGRUPPE: TStringField;
    knt9plan: TTable;
    knt9planKNR: TStringField;
    knt9planJAHR: TStringField;
    knt9planTYP: TStringField;
    knt9planNAME: TStringField;
    knt9planSALDO: TFloatField;
    knt9planBUDGET: TFloatField;
    knt9planGRUPPE: TStringField;
    knt8plan: TTable;
    knt8planKnr: TStringField;
    knt8planTyp: TStringField;
    knt8planName: TStringField;
    knt8planUstKnt: TStringField;
    knt8planUstP: TSmallintField;
    knt8planSaldo: TBCDField;
    knt8planBudget: TBCDField;
    knt8planGruppe: TStringField;
    knt8planLastAnr: TSmallintField;
    knt8planSeite: TSmallintField;
    j9: TTable;
    j9SOLLKNT: TStringField;
    j9HABENKNT: TStringField;
    j9USTKNT: TStringField;
    j9USTP: TFloatField;
    j9SOLLBETRAG: TFloatField;
    j9HABENBETRAG: TFloatField;
    j9USTSOLL: TFloatField;
    j9USTHABEN: TFloatField;
    j9BUCHTEXT: TStringField;
    j9ANR: TFloatField;
    j9BELEG: TStringField;
    j9DATUM: TDateField;
    J1UstKnt: TStringField;
    J1UstP: TSmallintField;
    J1UstSoll: TBCDField;
    J1UstHaben: TBCDField;
    J1Anr: TSmallintField;
    J1Beleg: TStringField;
    knt9planSALDO_X: TFloatField;
    knt9planTOTAL: TFloatField;
    j9JAHR: TStringField;
    EARechnung1: TMenuItem;
    FaKennungen: TListBox;
    ag2: TRichEdit;
    Pruefen: TMenuItem;
    fiamkonto: TTable;
    fiamkontoSollBetrag: TBCDField;
    fiamkontoHabenBetrag: TBCDField;
    fiamkontoGKnt: TStringField;
    fiamkontoKnr: TStringField;
    IGErwerb1: TMenuItem;
    ListBoxUst: TListBox;
    Speichern2: TMenuItem;
    Laden2: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    HuBHdoku: TMenuItem;
    HuBHHomepage1: TMenuItem;
    N4: TMenuItem;
    AlleKonten: TMenuItem;
    N5: TMenuItem;
    kontodruckaufEinzelseiten1: TMenuItem;
    HuBHFragenundAntworten1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure UpdateMenuItems(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure CutItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure Hilfethemen1Click(Sender: TObject);
    procedure LadenClick(Sender: TObject);
    procedure groesserClick(Sender: TObject);
    procedure NeuerMandant1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Kontoplan1Click(Sender: TObject);
    procedure Rohbilanz1Click(Sender: TObject);
    procedure AlleKonten1Click(Sender: TObject);
    procedure Journal1Click(Sender: TObject);
    procedure Einzelkonto1Click(Sender: TObject);
    procedure GruppensummenClick(Sender: TObject);
    procedure GruppenplanClick(Sender: TObject);
    procedure Druck1Click(Sender: TObject);
    procedure Beleg1Click(Sender: TObject);
    procedure BhInfodocbearbeiten1Click(Sender: TObject);
    procedure Rohbilanz2Click(Sender: TObject);
    procedure BudgetuebersichtClick(Sender: TObject);
    procedure GruppemplanRestClick(Sender: TObject);
    procedure GruppensummenundRest1Click(Sender: TObject);
    procedure NeueWhrung1Click(Sender: TObject);
    procedure Gruppenplan23Test1Click(Sender: TObject);
    procedure HauptbuchExport1Click(Sender: TObject);
    procedure SLKupdate1Click(Sender: TObject);
    procedure knt1planErzeugenClick(Sender: TObject);
    procedure EARechnung1Click(Sender: TObject);
    procedure PruefenClick(Sender: TObject);
    procedure IGErwerb1Click(Sender: TObject);
    procedure Speichern2Click(Sender: TObject);
    procedure Laden2Click(Sender: TObject);
    procedure HuBHdokuClick(Sender: TObject);
    procedure HuBHHomepage1Click(Sender: TObject);
    procedure AlleKontenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HuBHFragenundAntworten1Click(Sender: TObject);
  private
    zFileName, zParams, zDir: array[0..200] of Char;
    procedure ShowHint(Sender: TObject);
  public
  end;   

var
  _HuBH: T_HuBH;
  s, aktuellesVerzeichnis : string;

implementation

uses bhinfo, bhkonto, bhplan, bhjournal, bhbuchen, bhdru_kp, bhdru_rb,
  bhdru_K, bhdru_g1, bhdru_g2, shellapi, bhdru_bu, bhdru_gpr, bhdru_gsr,
  bheinhei, bhdru_23, bhalt, bhinit;

{$R *.DFM}

procedure T_HuBH.FormCreate(Sender: TObject);
begin
application.OnHint := ShowHint;
try
  session.AddPassword('hubsi');
except
if MessageDlg('Netzwerk nicht verfgbar. Lokal verwenden ?',
   mtConfirmation, [mbYes, mbNo], 2) = mrYes
   then begin session.NetFileDir:='c:\';
              session.AddPassword('hubsi');
   end else halt;
end;
//begin falsches PW
try
J1.Open;
except
  showmessage('Keine Zugriffsberechtigung auf Buchhaltungsdaten. Grnde:'+#10+
  '+ Arbeitsverzeichnis (Eigenschaften/Ausfhren in) muss auf Datenordner zeigen.'+#10+
  '+ Pfad C:\Dokumente und Einstellungen\....\Desktop\HuBH-d\ ist zu lange.'+#10+
  '+ Programm wird in C:/programme/huber/hubh-p/ gestartet (Falsch! Hier ist nur das Programm'+#10+
  '+ Datenbank hat zustzliche Verschlsselung und das Passwort ist falsch.'+#10+
  '! blicher Programmstart via Desktop/Buchhaltung/bhJAHR/bh.exe (gelbes BH-Logo)!'
  );
  ///raise;
  ///application.Destroy;
  application.Terminate;
end;
j1.Close;
//end falsches PW
Screen.OnActiveFormChange := UpdateMenuItems;
GetDir(0,aktuellesVerzeichnis);
caption:=caption+' >> "'+aktuellesVerzeichnis+'"';
try
  ag.Lines.LoadFromFile('huBHkey.dat');
except
  showmessage('Bitte registrieren Sie das Programm');
  showmessage('Sie erhalten dann die erforderlichen Passwrter und drfen einen beliebigen Mandaten-Namen eingeben');
  if InputBox('Input Box', 'Um das Programm zu testen, gebe "huweb.net" ein', '')<>'huweb.net' then application.Terminate;
end;
end;

procedure T_HuBH.ShowHint(Sender: TObject);
begin
  StatusBar.SimpleText := Application.Hint;
end;

procedure T_HuBH.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure T_HuBH.CutItemClick(Sender: TObject);
begin
  {cut selection to clipboard}
end;

procedure T_HuBH.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure T_HuBH.WindowTileItemClick(Sender: TObject);
begin
Tile;
end;

procedure T_HuBH.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure T_HuBH.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure T_HuBH.UpdateMenuItems(Sender: TObject);
begin
  SaveBtn.Enabled := MDIChildCount > 0;
  CutBtn.Enabled := MDIChildCount > 0;
  CopyBtn.Enabled := MDIChildCount > 0;
  PasteBtn.Enabled := MDIChildCount > 0;
  WindowCascadeItem.Enabled := MDIChildCount > 0;
  WindowTileItem.Enabled := MDIChildCount > 0;
  WindowArrangeItem.Enabled := MDIChildCount > 0;
  WindowMinimizeItem.Enabled := MDIChildCount > 0;
end;

procedure T_HuBH.FormDestroy(Sender: TObject);
begin
Screen.OnActiveFormChange := nil;
try knt1plan.EmptyTable except end;
//konten.dat lschen:
ag.text:='';
ag.Lines.SaveToFile('Konten.dat');
end;

procedure T_HuBH.HelpAboutItemClick(Sender: TObject);
begin
_info.windowstate:=wsnormal;
_info.BringToFront;
end;

procedure T_HuBH.SpeichernClick(Sender: TObject);
var Inifile: TIniFile;
    i:integer;
begin
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
 for I := MDIChildCount - 1 downto 0 do with inifile do begin
  writeinteger('Fenster','1'+MdiChildren[i].name,MDIChildren[I].top);
  writeinteger('Fenster','L'+MdiChildren[i].name,MDIChildren[I].left);
  writeinteger('Fenster','H'+MdiChildren[i].name,MDIChildren[I].height);
  writeinteger('Fenster','B'+MdiChildren[i].name,MDIChildren[I].width);
 end;
 for I:=0 to 5 do with inifile do
 if MDIChildren[I].windowstate=wsMinimized
 then writebool('Fenster','VISIBLE'+MdiChildren[i].name,false)
 else writebool('Fenster','VISIBLE'+MdiChildren[i].name,true);
finally
 Inifile.Free;
end;
end;

procedure T_HuBH.Hilfethemen1Click(Sender: TObject);
begin
  Application.HelpContext(0);
end;

procedure T_HuBH.LadenClick(Sender: TObject);
var Inifile: TIniFile;
i:integer;
begin
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
 for I:=0 to 5 do with inifile do
 if readbool('Fenster','VISIBLE'+MdiChildren[i].name,true)
 then MDIChildren[I].windowstate:=wsNormal
 else MDIChildren[I].windowstate:=wsMinimized;
 for I :=MDIChildCount-1 downto 0 do with inifile do begin
  MDIChildren[I].top   :=readinteger('Fenster','1'+MdiChildren[i].name,40*i);
  MDIChildren[I].left  :=readinteger('Fenster','L'+MdiChildren[i].name,20*i);
  MDIChildren[I].height:=readinteger('Fenster','H'+MdiChildren[i].name,330);
  MDIChildren[I].width :=readinteger('Fenster','B'+MdiChildren[i].name,700);
 end;
finally
 Inifile.Free;
end;end;

procedure T_HuBH.groesserClick(Sender: TObject);
begin
_Konto.windowState:=wsnormal;
_KontoPlan.windowState:=wsnormal;
_journal.windowState:=wsnormal;
_buchen.windowState:=wsnormal;
end;

procedure T_HuBH.NeuerMandant1Click(Sender: TObject);
var pfad,startdatum:string;
    datei:string[16];
    jahr:string;
    i:integer;
begin
if _buchen.einfuegung then begin
  showmessage('Funktion nur verfgbar wenn keine Buchungen eingefgt wurden.'+#10+#13
  +'Also Programm beenden, neu starten und diese Funktion erneut aufrufen.');
  exit;
end;
try startdatum:=datetostr(strToDate('1.1'));
except showmessage('Datum ist nicht auf Deutsches Datum eingestellt.');
       startdatum:='';
end;
inputQuery('Neues Jahr einrichten','Datum fr Erffnungsbuchungen',startdatum);
jahr:=floattostr(YearOf(now));
if InputQuery('Buchhaltung fr neues Jahr einrichten',
   'Jahr (1957 bis 9999) : ', jahr) and (jahr<>'')
then begin
  i:=strToInt(jahr);
  if (i<1000) or (i>9999) then begin
    showmessage('FEHLER: JAHR falsch!');
    exit; //------------------------>
  end;
  getdir(0,pfad);
  pfad:=extractFilePath(pfad)+'\BH'+jahr;
  if not _kontoplan.kontoplan.Locate('knr','EBK',[]) then begin
    showmessage('Bitte zuerst Erffnunskonto EBK mit Typ X einrichten !');
    exit;
  end;
  if pfad[length(pfad)]<>'\' then pfad:=pfad+'\';
  if pfad[length(aktuellesVerzeichnis)]<>'\' then aktuellesVerzeichnis:=aktuellesVerzeichnis+'\';
  if (pfad=aktuellesVerzeichnis) or  (pfad='') then begin
    showmessage('Selbes Verzeichnis nicht erlaubt!'); exit;
  end;
  {$I-}
  MkDir(pfad);
  {$I+}
  if (IOResult<>0) then if (messagedlg('ACHTUNG: Verzeichnis "'+pfad+
    '" ist schon vorhanden. SOLL KOPIERT WERDEN ? (Daten werden berschrieben !)',
    mtConfirmation,[mbYes,mbNo],8) = mrNo )
    then exit;
  //bertrag vorbereiten
  copyfile('JOURNAL.DB' ,PChar('JOURNAL1.DB'),false);
  j1.Active:=true;
  j1.EmptyTable;
  j1.Active:=false;
  if MessageDlg('Saldobertrag von B-K-U-Konten ?',mtConfirmation,[mbYes, mbNo],0)=mrYes
  then try
    j1.Active:=true;
    _kontoplan.kontoplan.First;
    _kontoplan.kontoplan.DisableControls;
    while not _kontoplan.kontoplan.Eof do try
      if  (length(_kontoplan.kontoplanTyp.Text)>0)
      and (_kontoplan.kontoplanTyp.Text[1] in ['B','K','U'])
      and (_kontoplan.kontoplanSaldo.value<>0)
      then begin
        j1.Append;
        j1sollBetrag.value:=abs(_kontoplan.kontoplanSaldo.value);
        j1habenBetrag.text:=j1sollBetrag.text;
        j1ok.text         :='*';
        try j1datum.value     :=strToDate(startdatum) except end;
        j1Buchtext.text   :='U-Konto Erffnung';
        if _kontoplan.kontoplanSaldo.value>0 then begin
          j1sollKnt.text    :=_kontoplan.kontoplanKnr.Text;
          j1habenKnt.text   :='EBK';
        end else begin
          j1sollKnt.text    :='EBK';
          j1habenKnt.text   :=_kontoplan.kontoplanKnr.Text;
        end;
        j1.post;
      end;
      _kontoplan.kontoplan.Next;
    except
      _kontoplan.kontoplan.EnableControls;
    end; //while kontoplan
    j1.Active:=false;
  except showmessage('Fehler bei Datei "JOURNAL1.DB"');
  end;
  //Dateien kopieren:
  _kontoplan.kontoplan.FlushBuffers;
  if not copyfile('BH.LNK',PChar(pfad+'BH.LNK'),false) then
    if not copyfile('BH.EXE',PChar(pfad+'BH.EXE'),false) then beep;
  if copyfile('JOURNAL1.DB' ,PChar(pfad+'JOURNAL.DB'),false) then
  if copyfile('JOURNAL1.DB' ,PChar(pfad+'JOURNAL1.DB'),false) then
  if copyfile('KNTPLAN.DB' ,PChar(pfad+'KNTPLAN.DB'),false) then
  if copyfile('KNTPLAN.PX' ,PChar(pfad+'KNTPLAN.PX'),false) then
  try if copyfile('KNTPLAN.FAM' ,PChar(pfad+'KNTPLAN.FAM'),false) then finally end;
  try if copyfile('KNTPLAN.TV' ,PChar(pfad+'KNTPLAN.TV'),false) then finally end;
  ///if copyfile('KNTPLAN.VAL' ,PChar(pfad+'KNTPLAN.VAL'),false) then
  if copyfile('KNTPLAN.XG0' ,PChar(pfad+'KNTPLAN.XG0'),false) then
  if copyfile('KNTPLAN.YG0' ,PChar(pfad+'KNTPLAN.YG0'),false) then
  if copyfile('KONTEN.DB' ,PChar(pfad+'KONTEN.DB'),false) then
  if copyfile('KONTEN.PX' ,PChar(pfad+'KONTEN.PX'),false) then
  if copyfile('KONTEN.XG0' ,PChar(pfad+'KONTEN.XG0'),false) then
  if copyfile('KONTEN.YG0' ,PChar(pfad+'KONTEN.YG0'),false) then
  if copyfile('HUBH.INI' ,PChar(pfad+'HUBH.INI'),false) then
  try if copyfile('VORLAGEN.TXT' ,PChar(pfad+'VORLAGEN.TXT'),false) then finally end;
  if copyfile('BHINFO.DOC' ,PChar(pfad+'BHINFO.DOC'),false) then
  try if copyfile('KNT1PLAN.DBF' ,PChar(pfad+'KNT1PLAN.DBF'),false) then finally end;
  try if copyfile('JOURNAL9.DB' ,PChar(pfad+'JOURNAL9.DB'),false) then finally end;
  try if copyfile('KNT9PLAN.DB' ,PChar(pfad+'KNT9PLAN.DB'),false) then finally end;
  try if copyfile('BhExport.exe' ,PChar(pfad+'BhExport.exe'),false) then finally end;
  try if copyfile('BhExport.lnk' ,PChar(pfad+'BhExport.lnk'),false) then finally end;
  try if copyfile('HuBH.hlp' ,PChar(pfad+'HuBH.hlp'),false) then finally end;
  try if copyfile('BhEd_.lnk' ,PChar(pfad+'BhEd_.lnk'),false) then finally end;
  try if copyfile('BhEd_.lnk' ,PChar(pfad+'BhEd_.lnk'),false) then finally end;
  try if copyfile('hubhkey.dat' ,PChar(pfad+'hubhkey.dat'),false) then finally end;
  try if copyfile('Belege' ,PChar(pfad+'belege'),false) then finally end;
  try
  if copyfile('JOURNAL9.DBF' ,PChar(pfad+'JOURNAL9.DBF'),false) then
  if copyfile('KNT9PLAN.DBF' ,PChar(pfad+'KNT9PLAN.DBF'),false) then
  finally
  end;
  with tabelle do begin
    Active := False;
    DatabaseName := '';
    TableType := ttParadox;
    TableName := pfad+'konten';
    EmptyTable;
    showmessage('Neues Jahr eingerichtet. '+#10+#13
    +'Diese Buchhaltung wird automatisch beendet!'+#10+#13
    +'Notiere folgenden Pfad (fr Datensicherung und Arbeitsverzeichnis) und starte HuBH vom Verzeichnis:"'+#10+#13
    +pfad+#10+#13
    +'Verwende dann im Fenster BUCHEN die "blaue Pfeil DN"-Taste um eventuell vorbereitete Erffnungsbuchungen einzutragen.');
  end;
  application.Terminate;
end else showmessage('ABBRUCH');
_kontoplan.kontoplan.Active:=true;
end;

procedure T_HuBH.Beenden1Click(Sender: TObject);
begin
close;
end;

procedure T_HuBH.Kontoplan1Click(Sender: TObject);
begin
_druKontoplan.report.Preview;
end;

procedure T_HuBH.Rohbilanz1Click(Sender: TObject);
begin
_druRohbilanz.Report.ReportTitle:='ROHBILANZ';
_druRohbilanz.QRSubDetail1.PrintIfEmpty:=false;
_druRohbilanz.report.preview;
end;

procedure T_HuBH.AlleKonten1Click(Sender: TObject);
begin
_druKonten.Master.ForceNewPage:=kontodruckaufeinzelseiten1.Checked;
_druKonten.konto.filter:=
'not( (typ=''B'') or (typ=''b'') or (typ=''K'') or (typ='':'') or (typ=''k'') ) and (saldo<>null)';
_druKonten.report.preview;
end;

procedure T_HuBH.Journal1Click(Sender: TObject);
begin
_Journal.B_drujournalClick(sender);
end;

procedure T_HuBH.Einzelkonto1Click(Sender: TObject);
var s:string[10];
begin
_konto.bringtofront;
s:=InputBox('Einzelkontoausdruck', 'Kontofilter oder ESC fr Hilfe:', '');
s:=ansiuppercase(s);
if s='' then
  showmessage('Whle im Fenster Hauptbuch ein Konto und verwende "Druck-Ikon" oder verwende '
  +'einen Konfofilter welcher aus einigen Anfangsbuchstaben des Kontonamens besteht, um einige '
  +'Konten auf Einzelseiten zu drucken. Mit "*" werden alle bebuchten Konten auser B+K gedruckt.'
  +'auf Einzelseiten gedruckt.')
else begin
  if s='*' then
    _druKonten.konto.filter:=
    'not( (typ=''B'') or (typ=''b'') or (typ=''K'') or (typ='':'') or (typ=''k'') ) and (saldo<>null)'
  else _druKonten.konto.filter:='not( (typ='':'') or saldo=NULL )'+
       ' and knr='''+s+'*''';
  _druKonten.Master.ForceNewPage:=kontodruckaufeinzelseiten1.Checked;
  _druKonten.report.preview;
  _druKonten.Master.ForceNewPage:=false;
  _druKonten.konto.filter:='';
end;
end;

procedure T_HuBH.GruppensummenClick(Sender: TObject);
begin
_druGruppensummen.report.Preview;
end;

procedure T_HuBH.GruppenplanClick(Sender: TObject);
begin
_druGruppen.report.Preview;
end;

procedure T_HuBH.Druck1Click(Sender: TObject);
begin
_konto.k.first;
{if (_konto.kKnr.text='')
   and (_buchen.SollKnt.text<>'')
   and (_buchen.HabenKnt.text<>'')
   then _konto.k.delete;                 }
end;

procedure T_HuBH.Beleg1Click(Sender: TObject);
begin
_buchen.beleganzeige(_journal.Jbeleg.Text);
end;

procedure T_HuBH.BhInfodocbearbeiten1Click(Sender: TObject);
begin
if  ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName,'BhInfo.doc'),
    StrPCopy(zParams,''),
    StrPCopy(zDir,''), SW_SHOWDEFAULT)    < 33
then showmessage('"BhInfo.doc" fehlt.');
end;

procedure T_HuBH.Rohbilanz2Click(Sender: TObject);
begin
_druRohbilanz.Report.ReportTitle:='ROHBILANZ +';
_druRohbilanz.QRSubDetail1.PrintIfEmpty:=true;
_druRohbilanz.report.preview;
end;

procedure T_HuBH.BudgetuebersichtClick(Sender: TObject);
begin
_druBudget.report.preview;
end;

procedure T_HuBH.GruppemplanRestClick(Sender: TObject);
begin
_drugruppenrest.Report.Preview;
end;

procedure T_HuBH.GruppensummenundRest1Click(Sender: TObject);
begin
_druGruppensummenRest.report.Preview;
end;

procedure T_HuBH.NeueWhrung1Click(Sender: TObject);
begin
if _buchen.einfuegung then begin
  showmessage('Funktion nur verfgbar wenn keine Buchungen eingefgt wurden.'+#10+#13
  +'Also Programm beenden, neu starten und diese Funktion erneut aufrufen.')
end else begin
  _kontoplan.kontoplan.FlushBuffers;
  _einheit.ShowModal;
end;
end;

procedure T_HuBH.Gruppenplan23Test1Click(Sender: TObject);
begin
_druGruppen1.report.Preview;
end;

procedure T_HuBH.HauptbuchExport1Click(Sender: TObject);
var x,kn:string[20];
    ch:char;
const y=#9;
begin
ch:=DecimalSeparator;
DecimalSeparator:='.';
try
with _konto do begin
  ag.Clear;
  k.First;
  ag.Lines.Add(y+y+y+y+'KONTOPLAN (Nr, UstP, Saldo, Typ, Text)');
  while not k.Eof do begin
    DecimalSeparator:=',';
    kn:=kKnr.Text;
    ag.Lines.Add(kn+y+kUstP.Text+y+format('%15.2f',[kSaldo.value])
                  +y+kTyp.text+y+kName.Text);
    k.Next;
  end;
  k.First;
  ag.Lines.Add('');
  ag.Lines.Add(y+y+y+'###########'+y+'K O N T E N : ###############');
  ag.Lines.Add(y+y+y+y+'KONTO, Ust, Saldo, Typ, Name');
  ag.Lines.Add(y+y+y+y+'Knr,GegenKnr,Betrag,Datum,Text,Anr,Beleg,#');
  while not k.Eof do begin
    kn:=kKnr.Text;
    ag.Lines.Add(kn+y+kUstP.Text+y+kSaldo.Text+y+kTyp.text+y+kName.Text);
    k2.First;
    while not k2.Eof do begin
      DecimalSeparator:=',';     //200710
      x:=format('%15.2f',[k2sollbetrag.value-k2habenbetrag.value]);  //floattostr(k2sollbetrag.value-k2habenbetrag.value);  //

      ag.Lines.Add(kn+y+k2GKnt.Text+y+x+y+k2datum.text+y+k2buchtext.Text+y+k2Anr.Text+y+k2beleg.Text+y+k2bnr.text);
      k2.Next;
    end;
    k.Next;
    ag.Lines.Add(' -----------------');
  end;
  ag.Lines.SaveToFile('konten.csv');
end;
finally DecimalSeparator:=ch;
end;
showmessage('Datei "Konten.csv" (Tab getrennt) wurde angelegt. Beachten Sie, dass diese Datei NICHT Passwortgeschtzt ist und nur sichtbar ist, solange HuBH gestartet bleibt!');
end;

procedure T_HuBH.SLKupdate1Click(Sender: TObject);
var jahr:string[4];
   anzahlJahre:integer;
begin
if FileExists('knt9plan.db') then begin
  knt9plan.TableType:=ttParadox;
  j9.TableType:=ttParadox;
  knt9plan.TableName:='knt9plan.db';
  j9.TableName:='journal9.db';
end else begin
  showmessage('Funktion in dieser Version nicht verfgbar');
  exit;
end;
_alt.J.Close;
_alt.knt9plan.Close;
statusbar.SimpleText:='*** Erzeuge "knt9plan" (Kontoplan ber alle Jahre)';
//DBASE Kontoplan alle Jahre:
knt9plan.EmptyTable;
knt9plan.Open;
jahr:=inttostr(yearOf(date)-7);
anzahljahre:=0;
repeat
 try
  knt8plan.TableName:=copy(aktuellesverzeichnis,1,length(aktuellesverzeichnis)-4)+jahr+'\KNTPLAN.DB';    //1997
  knt8plan.Open;
  while not knt8plan.Eof do begin
    knt9plan.Append;
    knt9planJAHR.Value:=jahr;
    knt9planKNR.Value:=knt8planKnr.Value;
    knt9planTYP.Value:=knt8planTyp.Value;
    knt9planNAME.Value:=knt8planName.Value;
    knt9planSALDO.Value:=knt8planSaldo.Value;
    knt9planBUDGET.Value:=knt8planBudget.Value;
    knt9planGRUPPE.Value:=knt8planGruppe.Value;
    knt9plan.Post;
    knt8plan.Next;
  end;
  knt8plan.close;
  inc(anzahljahre);
 except
 end;
 jahr:=inttostr(strtoint(jahr)+1);
until jahr=inttostr(yearOf(date));
knt9plan.Close;
statusbar.SimpleText:='*** "knt9plan" OK';
//journal alle Jahre:
J9.EmptyTable;
J9.Open;
jahr:=floattostr(yearof(now)-7);
repeat
 try
  J1.TableName:=copy(aktuellesverzeichnis,1,length(aktuellesverzeichnis)-4)+jahr+'\journal.DB';    //1997
//  showmessage(j1.TableName);
  statusbar.SimpleText:='*** Erzeuge "journal9" (Journal ber alle Jahre): '+J1.TableName;
  J1.Open;
  while not J1.Eof do begin
    J9.Append;
    J9Jahr.Value:=jahr;
    J9sollknt.Value:=j1sollknt.Value;
    J9habenknt.Value:=j1habenknt.Value;
    J9sollbetrag.Value:=j1sollbetrag.Value;
    J9habenbetrag.Value:=j1habenbetrag.Value;
    J9datum.Value:=j1datum.Value;
    J9buchtext.Value:=j1buchtext.Value;
    J9ustknt.Value:=j1ustknt.Value;
    J9ustp.Value:=j1ustp.Value;
    J9ustsoll.Value:=j1ustsoll.Value;
    J9usthaben.Value:=j1usthaben.Value;
    J9anr.Value:=j1anr.Value;
    J9beleg.Value:=j1beleg.Value;
    J9.Post;
    J1.Next;
  end;
  J1.close;
 except
 end;
 jahr:=inttostr(strtoint(jahr)+1);
until jahr=floattostr(yearof(now));
J9.Close;
//Update Saldo ohne X:
J9.Open;
J9.First;
knt9plan.Open;
while not J9.eof do begin
  //Jahressummen eintragen
  knt9plan.Locate('knr;jahr',VarArrayOf([J9sollknt.Value,J9jahr.Value]),[]);
  if uppercase(knt9planTYP.Value)='X' then begin J9.Next; continue; end; //-->
  knt9plan.Locate('knr;jahr',VarArrayOf([J9habenknt.Value,J9jahr.Value]),[]);
  if uppercase(knt9planTYP.Value)='X' then begin J9.Next; continue; end; //-->
  knt9plan.Locate('knr;jahr',VarArrayOf([J9sollknt.Value,J9jahr.Value]),[]);
  knt9plan.Edit;
  statusbar.SimpleText:='*** Saldo ohne X-Buchungen wird berechnet: '+J9jahr.Text;
  if J9jahr.Value<='2001'
  then knt9planSALDO_X.Value:=knt9planSALDO_X.Value+J9sollbetrag.Value/13.7603
  else knt9planSALDO_X.Value:=knt9planSALDO_X.Value+J9sollbetrag.Value;
  knt9plan.Post;
  knt9plan.Locate('knr;jahr',VarArrayOf([J9habenknt.Value,J9jahr.Value]),[]);
  knt9plan.Edit;
  if J9jahr.Value<='2001'
  then knt9planSALDO_X.Value:=knt9planSALDO_X.Value-J9habenbetrag.Value/13.7603
  else knt9planSALDO_X.Value:=knt9planSALDO_X.Value-J9habenbetrag.Value;
  knt9plan.Post;
  J9.Next;
end;
J9.Close;
knt9plan.Close;
_alt.J.open;
_alt.knt9plan.Open;
showmessage('Datei "Knt9.db(f)" und "Journal9.db(f) wurde erzeugt und enthlt nun Daten der vergangenen '
  +inttostr(anzahlJahre)+' Jahre.');
end;

procedure T_HuBH.knt1planErzeugenClick(Sender: TObject);
begin
{//Jahreskontoplan DBASE:
knt1plan.EmptyTable;
knt1plan.Open;
_kontoplan.kontoplan.First;
while not _kontoplan.kontoplan.Eof do begin
  knt1plan.Append;
  knt1planKNR.Value:=_kontoplan.kontoplanKnr.Value;
  knt1planTYP.Value:=_kontoplan.kontoplanTyp.Value;
  knt1planNAME.Value:=_kontoplan.kontoplanName.Value;
  knt1planSALDO.Value:=_kontoplan.kontoplanSaldo.Value;
  knt1planBUDGET.Value:=_kontoplan.kontoplanBudget.Value;
  knt1planGRUPPE.Value:=_kontoplan.kontoplanGruppe.Value;
  knt1plan.Post;
  _kontoplan.kontoplan.Next;
end;
knt1plan.close;
showmessage('Kontoplan "knt1plan.dbf" im ungeschtzten DBASE Format wurde erzeugt');  }
end;

procedure T_HuBH.EARechnung1Click(Sender: TObject);
var i           : integer;
    Ini         : TIniFile;
    faKennung   : string[1];
    ik          : integer;
    geschuetzt  : extended;
    jahr        : integer;
    sumE,sumA,sumB1,sumB2 : extended;
    v0, E0, E10, E20, v10, v20 : extended;
    n1,n2,n3 : extended;
    xE0, xE10, xE20, xv0, xv10, xv20, xg, xv : extended;
    drucken, summenberechnung : boolean;
    sx,sy : string[10];
    ss : tstrings;
  procedure fiamsumme(vz:char);
  begin
      //FIAM Kennzahlen-Summenblatt-Berechnung:
      sx:=copy(knt8planName.Value,1,pos(':',knt8planName.Value)-1);
      if (sx<>'') and (length(sx)<10) then
        ss.Add(format('%-10.10s%1.1s%12.2f  %-10.10s %-45.45s',
         [sx,vz,knt8planSaldo.Value,knt8planKnr.value,
         copy(knt8planName.Value,pos(':',knt8planName.Value)+1,999)]));
      //Fiam ende
  end;
begin
n1:=0; n2:=0; n3:=0;
ss:= TStringList.Create;
ag2.Clear;
Ini:= TIniFile.Create('.\HuBH.Ini');
knt8plan.open;
xe0:=0; xe10:=0; xe20:=0; xv0:=0; xv10:=0; xv20:=0; xg:=0; xv:=0;
//drucken:=MessageDlg('auch Drucken ? ',mtConfirmation,[mbYes, mbNo], 0)=mrYes;
drucken:=false;
try
  jahr:=yearof(ini.readDate('Datum','Buchung1',0));
  ag.Clear; //FIAM-Summen
  ag.Lines.Add(format('Buchhaltung %4.4d %-86.86s',[jahr,ini.ReadString('Mandant','name','Heinrich Huber')]));
  ag.Lines.Add(format('%-91.91s',[
  '=====================================================================================================']));
  ag.Lines.Add(format('%91.91s ',['UMSATZSTEUER - SUMMEN:']));
  ini.readsectionValues('Firmenkennungen',faKennungen.Items);
  for ik:=0 to faKennungen.Items.Count-1 do begin
    faKennung:=faKennungen.Items[ik];
    ag2.Clear;
    if copy(ini.ReadString('Firmenkennungen',fakennung,'EAR!'),1,1)='#'
      then summenberechnung:=false else summenberechnung:=true;
    ag2.Lines.Add(format('%-86.86s',[ini.ReadString('Mandant','name','Heinrich Huber')]));
    ag2.Lines.Add(format('%86.86s %4.4d',
      [ini.ReadString('Firmenkennungen',fakennung,'EAR!'),jahr]));
    ag.Lines.Add('');
    ag.Lines.Add(format('%-86.86s ',[ini.ReadString('Firmenkennungen',fakennung,'EAR!')]));
    ag2.Lines.Add(format('%-91.91s',[
    '=====================================================================================================']));
    ag2.Lines.Add('');
    //
    ag2.Lines.Add(format('%-92.82s ',['Einnahmen (Netto)']));
    ag2.Lines.Add(format('%-92.82s ',['---------']));
    knt8plan.First;
    e0:=0; sumE:=0; e10:=0; e20:=0;
    while not knt8plan.eof do begin
      if (copy(knt8planGruppe.Value,1,1)='E') and
         (copy(knt8planGruppe.Value,3,1)=faKennung)  and
         (knt8planSaldo.value<>0) then begin
        fiamsumme('.');
        ag2.Lines.Add(format('%-10.10s %-50.50s%30.2n',[knt8planKNR.value,knt8planName.value,knt8planSaldo.value*-1]));
        sumE:=sumE+knt8planSaldo.value;
        if knt8planUstP.Value=0  then e0 :=e0+knt8planSaldo.value;
        if knt8planUstP.Value=10 then e10:=e10+knt8planSaldo.value;
        if knt8planUstP.Value=20 then e20:=e20+knt8planSaldo.value;
      end;
      knt8plan.Next;
    end;
    //
    ag2.Lines.Add('');
    ag2.Lines.Add(format('%-92.82s ',['Ausgaben (Netto)']));
    ag2.Lines.Add(format('%-92.82s ',['---------']));
    knt8plan.First;
    v0:=0; sumA:=0; v10:=0; v20:=0;
    while not knt8plan.eof do begin
      if ( (copy(knt8planGruppe.Value,1,1)='A') or ((copy(knt8planGruppe.Value,1,1)='B')) ) and
         (copy(knt8planGruppe.Value,3,1)=faKennung)  and
         (knt8planSaldo.value<>0) then begin
        fiamsumme(' ');
        ag2.Lines.Add(format('%-10.10s %-50.50s%15.2n',[knt8planKNR.value,knt8planName.value,knt8planSaldo.value]));
        sumA:=sumA+knt8planSaldo.value;
        if knt8planUstP.Value=0  then v0 :=v0+knt8planSaldo.value;
        if knt8planUstP.Value=10 then v10:=v10+knt8planSaldo.value;
        if knt8planUstP.Value=20 then v20:=v20+knt8planSaldo.value;
      end;
      knt8plan.Next;
    end;
    sumE:=sumE*-1;
    ag2.Lines.Add(format('%-60s %-30.30s',['','------------------------------------------------------------']));
    ag2.Lines.Add(format('%-10.10s %-50s%15.2n%15.2n',['','',sumA,sumE]));
    if sumE<sumA then begin
      ag2.Lines.Add(format('%-60.60s %30.2n',['VERLUST',sumA-sumE]));
      if summenberechnung then xv:=xv+sumA-sumE;
      sumE:=sumA;
    end else begin
      ag2.Lines.Add(format('%-60.60s %15.2n',['GEWINN',sumE-sumA]));
      if summenberechnung then xg:=xg+sumE-sumA;
      sumA:=sumE;
    end;
    ag2.Lines.Add(format('%-60s %-30.30s',['','------------------------------------------------------------']));
    ag2.Lines.Add(format('%-10.10s %-50s%15.2n%15.2n',['','',sumA,sumE]));
    ag2.Lines.Add(format('%-60s %-30.30s',['','============================================================']));
    if e0<>0  then ag.Lines.Add(format('    MWST  0 : %15.2n%',[e0]));
    if e10<>0 then ag.Lines.Add(format('    MWST 10 : %15.2n%15.2n%15.2n',[e10,e10*0.1,e10*1.1]));
    if e20<>0 then ag.Lines.Add(format('    MWST 20 : %15.2n%15.2n%15.2n',[e20,e20*0.2,e20*1.2]));
    if v0<>0  then ag.Lines.Add(format('    VORST 0 : %15.2n%',[v0]));
    if v10<>0 then ag.Lines.Add(format('    VORST10 : %15.2n%15.2n%15.2n',[v10,v10*0.1,v10*1.1]));
    if v20<>0 then ag.Lines.Add(format('    VORST20 : %15.2n%15.2n%15.2n',[v20,v20*0.2,v20*1.2]));
    n1:=e0+e10++e20+v0+v10+v20;
    if summenberechnung then n2:=n2+n1;
    n3:=n3+n1;
    ag.Lines.Add(format('    NettoSum: %15.2n%',[n1]));
    xe0:=xe0+e0; xe10:=xe10+e10; xe20:=xe20+e20; xv0:=xv0+v0; xv10:=xv10+v10; xv20:=xv20+v20;
    ag2.Lines.SaveToFile(aktuellesVerzeichnis+'\EAR'+inttostr(jahr)+fakennung+'.txt');
    if drucken then ag2.Print('EA-Rechnung');
  end;

  knt8plan.Close;
  if ag2.Text=''
  then showmessage('In "HuBH.ini" feht der Eintrag [Firmenkennungen] (3.Buchstabe in Gruppe).')
  else showmessage('EA Rechnungen "EAR'+inttostr(jahr)+'x.txt" wurden im Pfad "'
       +aktuellesVerzeichnis+'\" gespeichert.');
finally
  Ini.Free;
end;

ag.Lines.Add('');
ag.Lines.Add(format('%-91.91s',[
'=====================================================================================================']));
ag.Lines.Add(format('%91.91s ',['UMSATZSTEUER - GESAMTSUMMEN:']));
ag.Lines.Add(format('    MWST 0   : %15.2n',[xe0]));
ag.Lines.Add(format('    MWST 10  : %15.2n%15.2n%15.2n',[xe10,xe10*0.1,xe10*1.1]));
ag.Lines.Add(format('    MWST 20  : %15.2n%15.2n%15.2n',[xe20,xe20*0.2,xe20*1.2]));
ag.Lines.Add(format('    MWST10+20: %15.2n%15.2n%15.2n',[xe10+xe20,xe10*0.1+xe20*0.2,xe10*1.1+xe20*1.2]));
ag.Lines.Add(format('    VORST 0  : %15.2n',[xv0]));
ag.Lines.Add(format('    VORST10  : %15.2n%15.2n%15.2n',[xv10,xv10*0.1,xv10*1.1]));
ag.Lines.Add(format('    VORST20  : %15.2n%15.2n%15.2n',[xv20,xv20*0.2,xv20*1.2]));
ag.Lines.Add(format('    VST10+20 : %15.2n%15.2n%15.2n',[xv10+xv20,xv10*0.1+xv20*0.2,xv10*1.1+xv20*1.2]));
ag.Lines.Add(format('    Gesamt   : %30.2n',[xe10*0.1+xe20*0.2+xv10*0.1+xv20*0.2]));
ag.Lines.Add('');
ag.Lines.Add(format('    Gewinn   : %15.2n',[xg]));
ag.Lines.Add(format('    Verlust  : %15.2n',[xv]));
ag.Lines.Add(format('    G-V      : %15.2n',[xg-xv])+' ohne Summen fr LWG und Privat (Firmenkennung=#...)');
ag.Lines.Add('');
ag.Lines.Add(format('    NettoSum-: %15.2n',[n2])+' Summe von "NettoSum" (oben)ohne Kennung #');
ag.Lines.Add(format('    NettoSum+: %15.2n',[n3])+' Summe von "NettoSum" (oben) mit Kennung #');
ag.Lines.Add('');
ag.Lines.Add(format('%-91.91s',[
'=====================================================================================================']));
ag.Lines.Add(format('%91.91s ',['UMSATZSTEUER - An FIAM gemeldet:']));
fiamkonto.open;
fiamkonto.First;
e0:=0;
while not fiamkonto.Eof do begin
  if fiamkontoGknt.Text='25USTBER' then begin
    ag.Lines.Add(format('berschuss   :%15.2n %-60.60',[fiamkontoSollbetrag.Value,j1buchtext.Text]));
    e0:=e0-fiamkontoSollbetrag.Value;
  end;
  if fiamkontoGknt.Text='35USTZALA' then begin
    ag.Lines.Add(format('Vorauszahlung:%15.2n %-60.60',[fiamkontoHabenbetrag.Value,j1buchtext.Text]));
    e0:=e0+fiamkontoHabenbetrag.Value;
  end;
  fiamkonto.Next;
end;
ag.Lines.Add(format    ('Summe        :%15.2n %-60.60s',[e0,'Bitte mit FIAM-Belegen vergleichen [  ]']));
fiamkonto.Close;
//----------------------------------------------------------------------------------

//fakennungen Missbrauch fr FIAM Kennzahlen-Summenblatt-Ausgabe:
fakennungen.Sorted:=true;
fakennungen.Clear;
fakennungen.Items.addStrings(ss);
ss.Free;
ag.Lines.Add('');
ag.Lines.Add(format('%-91.91s',[
'=====================================================================================================']));
ag.Lines.Add(format('%91.91s ',['Summen fr Finazamt-Formulare:']));
ag.Lines.Add('');
if fakennungen.Items.Count=0 then begin
  ag.lines.Add('Keine Auswertung, da Kontonamen mit "FIAM-Feldnummer:" beginnen mssen!');
  ag.Lines.SaveToFile(aktuellesVerzeichnis+'\EAR-FIAMsummen.txt');
  exit;
end;
e0:=0;
v0:=0;
sx:=fakennungen.Items[0];
for i:=0 to fakennungen.Items.Count-1 do begin
  sy:=fakennungen.Items[i];
  if sx<>sy then begin
    ag.Lines.Append(format('%-11.11s%12.2n',[sx,e0])+' ----------');  //print altname+summe
    ag.Lines.Append('');
    if copy(sx,1,2)<>copy(sy,1,2) then begin
      ag.Lines.Append(format('%-11.11s%12.2n',
         [copy(sx,1,2),v0]));  //print altkurzName+summe
      ag.Lines.Append('=======================');
      v0:=0;
    end;
    ag.Lines.Append('');
    sx:=sy;     //alt merken
    e0:=0;                        //sum=0
  end;
  //neue Zeile:
  ag.Lines.Append(fakennungen.Items[i]);
  sumA:=strtofloat(copy(fakennungen.Items[i],12,12));
  e0:=e0+sumA;
  v0:=v0+sumA;
end;
ag.Lines.Append(''); //letzte Endsumme ausgeben:
ag.Lines.Append(format('%-11.11s%12.2n',[sx,e0])+' ----------');  //print summe
ag.Lines.Append('');
ag.Lines.Append(format('%-11.11s%12.2n',[copy(sx,1,2),v0]));  //print summe
ag.Lines.Append('=======================');
ag.Lines.Append('');
ag.Lines.Append('LEGENDE:');
ag.Lines.Append('  . = rechte HABEN Spalte (typisch fr Einnahmen)');
ag.Lines.SaveToFile(aktuellesVerzeichnis+'\EAR-FIAMsummen.txt');
fakennungen.Sorted:=false;
//ende fiam

end;

procedure T_HuBH.PruefenClick(Sender: TObject);
var u10, u20,v10, v20,saldo : currency;
var s1,h1, s2,h2 : Currency;
  fehler:boolean;
begin
ag.Clear;
ag.Lines.Add('Prfung fr "'+aktuellesVerzeichnis+'" am '+datetostr(now));
ag.Lines.Add('');
ag.Lines.Add('Journalprfung:');
if _journal.jok.text<>_buchen.jok.text then _buchen.journalplusClick(sender);
s1:=0; h1:=0; s2:=0; h2:=0;
with _journal do try
  j.DisableControls;
  j.first;  _buchen.k.first;
  while not j.eof and ( (jok.text=GESICHERT) or (jOk.text=GEBUCHT) ) do begin
    s1:=s1+jSollBetrag.value+jUstSoll.value;
    h1:=h1+jHabenBetrag.value+jUstHaben.value;
    j.next;
  end;
  while not (_buchen.k.eof) do begin
    s2:=s2+_buchen.kSollBetrag.value;
    h2:=h2+_buchen.kHabenBetrag.value;
    _buchen.k.next;
  end;
finally
  j.EnableControls;
end;
if (s1<>s2) or (h1<>h2) or (s1<>h1)
  then showmessage('FEHLER: SOLL/HABEN ungleich oder JOURNAL ungleich KONTO !!')
  else ag.Lines.Add('  Saldengleichheit im JOURNAL');
ag.Lines.Add('');
ag.Lines.Add('Konten fr Innergemeinschaftliche Erwerbe:');
_kontoplan.kontoplan.First;
u10:=0; u20:=0; v10:=0; v20:=0;
fehler:=false;
while not _kontoplan.kontoplan.Eof do with _kontoplan do begin
  if (pos('*E10',kontoplanKnr.Value)>0) then
    ag.Lines.Add(kontoplanKnr.Value+'  '+kontoplanName.Value);
  if (pos('*E20',kontoplanKnr.Value)>0) then
    ag.Lines.Add(kontoplanKnr.Value+'  '+kontoplanName.Value);
  if (kontoplanUstKnt.Value<>'') and
    (_init.ListBoxUst.Items.IndexOf(kontoplanUstKnt.Value)=-1) then begin
    ag.Lines.Add('UST-FEHLER bei: '+kontoplanKnr.text+'  '+kontoplanName.Value);
    fehler:=true;
  end;
  kontoplan.Next;
end;
ag.Lines.Add('');
ag.Lines.Add('Eventuelle Fehler bei der Konto-Einrichtung:');
ag.Lines.Add('UST: zeigt evt. fehlenden UST % Wert');
ag.Lines.Add('E,A,AE: zeigt evt. Fehler bei Gruppenzuordnung bei XY Schema (X=E, A oder B, Y=1 oder 2)');
ag.Lines.Add('');
_kontoplan.kontoplan.First;
u10:=0; u20:=0; v10:=0; v20:=0;
saldo:=0;
while not _kontoplan.kontoplan.Eof do with _kontoplan do begin
  saldo:=saldo+kontoplanSaldo.Value;
  if (kontoplanUstP.Value<>0)
     and (copy(kontoplanUstP.Text,1,1)<>copy(kontoplanGruppe.text,2,1))
     and not ( (copy(kontoplanGruppe.text,1,1)='A') or (copy(kontoplanGruppe.text,1,1)='B') or
               (copy(kontoplanGruppe.text,1,1)='E')  )
     then
    ag.Lines.Add('AE: '+kontoplanKnr.text+'  '+kontoplanName.Value);
  if uppercase(kontoplanTyp.Value)='E' then begin
    if (copy(kontoplanUstknt.text,1,1)<>'') and (kontoplanUstP.text='')
      then ag.Lines.Add('UST? '+kontoplanKnr.text+'  '+kontoplanName.Value);
    if copy(kontoplanGruppe.text,1,1)<>'E' then
      ag.Lines.Add('E : '+kontoplanKnr.text+'  '+kontoplanName.Value);
    if kontoplanUstP.Value=10 then u10:=u10+kontoplanSaldo.Value;
    if kontoplanUstP.Value=20 then u20:=u20+kontoplanSaldo.Value;
  end else if uppercase(kontoplanTyp.Value)='A' then begin
    if (copy(kontoplanUstknt.text,1,1)<>'') and (kontoplanUstP.text='')
      then ag.Lines.Add('UST? '+kontoplanKnr.text);
    if not ( (copy(kontoplanGruppe.text,1,1)='A') or (copy(kontoplanGruppe.text,1,1)='B') ) then
      ag.Lines.Add('A : '+kontoplanKnr.text+'  '+kontoplanName.Value);
    if kontoplanUstP.Value=10 then v10:=v10+kontoplanSaldo.Value;
    if kontoplanUstP.Value=20 then v20:=v20+kontoplanSaldo.Value;
  end;
  kontoplan.Next;
end;
ag.Lines.Add('----------------------------------------------------------------');
ag.Lines.Add('Summen (E/A Saldo):');
ag.Lines.Add(format('  u10=%n (%n) u20=%n (%n)  v10=%n (%n)  v20=%n (%n)',
  [u10, u10*0.1, u20, u20*0.20, v10, v10*0.1, v20, v20*0.20]));
ag.Lines.Add('Summe Vorsteuer (10+20): '+floattostr(v10+v20)
  +'   ('+floattostr(v10*0.1+v20*0.20)+')');
ag.Lines.Add('Summe Saldo (muss 0 sein!): '+floattostr(saldo));
if fehler or (saldo<>0)
  then showmessage('!! FEHLER !! Ergebnis siehe: '+aktuellesverzeichnis+'\prfung.txt')
  else; //showmessage('Prfung OK (Saldengleicheit) Ergebnis siehe: '+aktuellesverzeichnis+'\prfung.txt');
ag.Lines.SaveToFile(aktuellesverzeichnis+'\prfung.txt');
end;

procedure T_HuBH.IGErwerb1Click(Sender: TObject);
const r='          ';
var est10,est20,est10s,est20s,ustv,estXX,estXXs,estTotal:currency;
    ust  : array [0..6] of currency;
    usts : array [0..6] of currency;
    i,monat,jahr : integer;
    mandant:string[30];
    inifile : Tinifile;
    altmonat,altjahr:integer;
    IGprozent:integer;
begin
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
 inifile.readsection('UstKonten',listBoxUst.items);
 mandant:=inifile.ReadString('Mandant','name','Heinrich Huber');
 IGprozent:=inifile.readinteger('Einstellungen','IGprozent',0);
 inifile.WriteInteger('Einstellungen','IGprozent',IGprozent);
finally
 Inifile.Free;
end;
_journal.J.First;
jahr:=yearof(_journal.Jdatum.Value);
ag2.Clear;
ag2.Lines.Add(r+format('Buchhaltung %4.4d %-86.86s',[jahr,mandant]));
ag2.Lines.Add(r+format('%-91.91s',[
  '=====================================================================================================']));
est10s:=0;
est20s:=0;
estXXs:=0;
estTotal:=0;
for i:=0 to 6 do begin
  usts[i]:=0;
end;
with _journal do begin
  J.DisableControls;
  for monat:=1 to 12 do begin
    if (((monat-1) mod 3)=0) or _init.monatsberechnung.Checked then begin
      est10:=0;
      est20:=0;
      estXX:=0;
      for i:=0 to 6 do begin
        ust[i]:=0;
      end;
    end;
    _Journal.j.First;
    altjahr:=yearof(Jdatum.Value);
    altmonat:=0;
    while not j.eof do begin
      if (monthof(Jdatum.Value)<altmonat) and (monat=1) and
         ( (Jok.Value='#') or (Jok.Value='=') )
      then ag2.Lines.Add(r+'Datumfehler bei # '+Jbnr.Text+' ('+Jdatum.Text+')');
      altmonat:=monthof(Jdatum.Value);
      if (monthof(Jdatum.Value)=monat) and (yearof(Jdatum.Value)=altjahr) and
          ( (Jok.Value='#') or (Jok.Value='=') )
      then begin
        if pos('*E10',JSollKnt.Text)>0  then est10:=est10+jSollbetrag.Value;
        if pos('*E10',JHabenKnt.Text)>0 then est10:=est10-jHabenbetrag.Value;
        if pos('*E20',JSollKnt.Text)>0  then est20:=est20+jSollbetrag.Value;
        if pos('*E20',JHabenKnt.Text)>0 then est20:=est20-jHabenbetrag.Value;
        if pos('*EX',JSollKnt.Text)>0    then estXX:=estXX+jSollbetrag.Value;
        if pos('*EX',JHabenKnt.Text)>0   then estXX:=estXX-jHabenbetrag.Value;
        if pos('*E',JSollKnt.Text)>0    then estTotal:=estTotal+jSollbetrag.Value;
        if pos('*E',JHabenKnt.Text)>0   then estTotal:=estTotal-jHabenbetrag.Value;
        for i:=0 to listBoxUst.items.count-1 do begin
          if JUstknt.Value=listBoxUst.items[i] then begin
            ust[i]:=ust[i]+JUsthaben.Value-JUstSoll.Value;
          end;
        end;
      end;
      j.next;
    end;
    if ((monat mod 3)=0) or _init.monatsberechnung.Checked then begin
      est10s:=est10s+est10;
      est20s:=est20s+est20;
      estXXs:=estXXs+estXX;
      for i:=0 to listBoxUst.items.count-1 do begin
        usts[i]:=usts[i]+ust[i];
      end;
      ag2.Lines.Add(r+'Monat '+inttostr(monat));
      if est10<>0 then
        ag2.Lines.Add(r+format('I.g.Erwerbsteuer 10%%: %15.2n %15.2n',[est10,est10*0.10]));
      if est20<>0 then
        ag2.Lines.Add(r+format('I.g.Erwerbsteuer 20%%: %15.2n %15.2n',[est20,est20*0.20]));
      if estXX<>0 then
        ag2.Lines.Add(r+format('I.g.Erwerbsteuer %2d%%: %15.2n %15.2n',[IGprozent,estXX,estXX*IGprozent/100]));
      //IG-Erwerbsteuer:
      ag.text:='';
      if fileexists('ustmeldung'+inttostr(monat)+'.txt') then begin
        ag.Lines.LoadFromFile('ustmeldung'+inttostr(monat)+'.txt');
        ag.Lines.Add(''); ag.Lines.Add('');
        ag.Lines.Add(''); ag.Lines.Add('');
        ag.Lines.Add(''); ag.Lines.Add('');
        while ag.Lines.Count > 15 do ag.Lines.Delete(14);
        ag.Lines.Add(r+format('I.g.Erwerbsteuer 10%%: %15.2n %15.2n',[est10,est10*0.10]));
        ag.Lines.Add(r+format('I.g.Erwerbsteuer 20%%: %15.2n %15.2n',[est20,est20*0.20]));
        ag.Lines.Add(r+format('I.g.Erwerbsteuer %2d%%: %15.2n %15.2n',[IGprozent,estXX,estXX*IGprozent/100]));
        ag.Lines.Add(r+format('I.g.Erwerbsteuer sum: %15.2n %15.2n',[est10+est20+estXX, est10*0.10+est20*0.20+estXX*IGprozent/100]));
        ag.Lines.SaveToFile('ustmeldung'+inttostr(monat)+'.txt');
      end;
      //
      ustv:=0;
      for i:=0 to listBoxUst.items.count-1 do begin
        ag2.Lines.Add(r+format('UST-Knt:%-15.15s%15.15s%15.2n',[listBoxUst.items[i],'',ust[i]]));
        ustv:=ustv+ust[i];
      end;
      ag2.Lines.Add(r+format('UST-Vorauszahlung(+)   %30.2n',[ustv]));
    end;
  end;
  ag2.Lines.Add('');
  ag2.Lines.Add('');
  ag2.Lines.Add(r+'Monat 1-12');
  ag2.Lines.Add(r+format('I.g.Erwerbsteuer 10%%: %15.2n %15.2n',[est10s,est10s*0.10]));
  ag2.Lines.Add(r+format('I.g.Erwerbsteuer 20%%: %15.2n %15.2n',[est20s,est20s*0.20]));
  ag2.Lines.Add(r+format('I.g.Erwerbsteuer %2d%%: %15.2n %15.2n',[IGprozent,estXXs,estXXs*IGprozent/100]));
  ag2.Lines.Add(r+format('I.g.Erwerbsteuer SUM: %15.2n',[estTotal]));
  ag2.Lines.Add('');
  ustv:=0;
  for i:=0 to listBoxUst.items.count-1 do begin
    ag2.Lines.Add(r+format('UST-Knt:%-15.15s%15.15s%15.2n',[listBoxUst.items[i],'',usts[i]]));
    ustv:=ustv+usts[i];
  end;
  ag2.Lines.Add(r+format('UST-Vorauszahlung(+)   %30.2n',[ustv]));
  J.EnableControls;
  ag2.Lines.SaveToFile('.\UST Voranmeldung.txt');
  showmessage('Datei .\UST Voranmeldung.txt erstellt');
  ag2.Print('UST Voranmeldung');
end;
end;

procedure T_HuBH.Speichern2Click(Sender: TObject);
var Inifile: TIniFile;
    i:integer;
begin
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
 for I := MDIChildCount - 1 downto 0 do with inifile do begin
  writeinteger('Fenster2','1'+MdiChildren[i].name,MDIChildren[I].top);
  writeinteger('Fenster2','L'+MdiChildren[i].name,MDIChildren[I].left);
  writeinteger('Fenster2','H'+MdiChildren[i].name,MDIChildren[I].height);
  writeinteger('Fenster2','B'+MdiChildren[i].name,MDIChildren[I].width);
 end;
 for I:=0 to 5 do with inifile do
 if MDIChildren[I].windowstate=wsMinimized
 then writebool('Fenster2','VISIBLE'+MdiChildren[i].name,false)
 else writebool('Fenster2','VISIBLE'+MdiChildren[i].name,true);
finally
 Inifile.Free;
end;
end;

procedure T_HuBH.Laden2Click(Sender: TObject);
var Inifile: TIniFile;
i:integer;
begin
Inifile:= TIniFile.Create('.\HuBH.Ini');
try
 for I:=0 to 5 do with inifile do
 if readbool('Fenster2','VISIBLE'+MdiChildren[i].name,true)
 then MDIChildren[I].windowstate:=wsNormal
 else MDIChildren[I].windowstate:=wsMinimized;
 for I :=MDIChildCount-1 downto 0 do with inifile do begin
  MDIChildren[I].top   :=readinteger('Fenster2','1'+MdiChildren[i].name,40*i);
  MDIChildren[I].left  :=readinteger('Fenster2','L'+MdiChildren[i].name,20*i);
  MDIChildren[I].height:=readinteger('Fenster2','H'+MdiChildren[i].name,330);
  MDIChildren[I].width :=readinteger('Fenster2','B'+MdiChildren[i].name,700);
 end;
finally
 Inifile.Free;
end;
end;

procedure T_HuBH.HuBHdokuClick(Sender: TObject);
begin
s:=_init.programmpfad+'BhDoku.pdf';
if ShellExecute(Handle,'open',Pchar(s),nil,nil,SW_SHOWDEFAULT) <33 then
  showmessage('Vermutlich "'+s+'" nicht vorhanden.');  //
{
s:=_init.programmpfad+'BhDoku.pdf';
if  ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName,s),
    StrPCopy(zParams,''),
    StrPCopy(zDir,''), 0)    < 33
then showmessage(s+' kann nicht geffnet werden!');       }
end;

procedure T_HuBH.HuBHHomepage1Click(Sender: TObject);
begin
s:='http://heinrich-huber.com/hubh.htm';
if ShellExecute(Handle,'open',Pchar(s),nil,nil,SW_SHOWDEFAULT) <33 then
  showmessage('Vermutlich "'+s+'" nicht vorhanden.');  //
end;

procedure T_HuBH.AlleKontenClick(Sender: TObject);
begin
_druKonten.Master.ForceNewPage:=kontodruckaufeinzelseiten1.Checked;
_druKonten.konto.filter:='(saldo<>null)';
_druKonten.report.preview;
end;

procedure T_HuBH.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if MessageDlg('JA: Daten PRFEN und wenn Fehlerfrei automatisch beenden oder NEIN: nicht prfen und sofort beenden.',
   mtConfirmation, [mbNo, mbYes], 2) <> mrNO
   then _hubh.PruefenClick(sender);
end;

procedure T_HuBH.HuBHFragenundAntworten1Click(Sender: TObject);
begin
s:='http://heinrich-huber.com/hubh-fua.htm';
if ShellExecute(Handle,'open',Pchar(s),nil,nil,SW_SHOWDEFAULT) <33 then
  showmessage('Vermutlich "'+s+'" nicht vorhanden.');  //
end;

end.

